package com.csc.library.components;

public class Tel extends Text {
	private static final long serialVersionUID = 1L;

	public Tel() {
		this.type = "tel";
	}

	public Tel(ComponentManager cm) {
		super(cm);
		if (cm.getProperty("size").equals("")) {
			this.setSize(cm.getStringWidth());
		} else {
			this.setSize(cm.getProperty("size"));
		}

		this.setMax(cm.getProperty("maxsize"));
		this.setDir(cm.getProperty("dir"));

		this.onKeyPress = "chkInputNumPhone(event);" + this.onKeyPress;

		this.ini();
	}

	public void ini() {
		String label2;
		label2 = "<input type=\"hidden\"" 
				+ " name=\"" + this.name + "\""
				+ " value=\"" + this.value + "\"" + " alt=\""
				+ ((com != null) ? com.getAlt() : "") + "\"" + "  >";
		ListBox lbox = new ListBox();
		lbox.setUProfile(this.uPro);
		lbox.setLabel("TelArea");
		if (this.name.substring(0, 2).equals("__"))
			lbox.setName(this.name.substring(2) + "area");
		else
			lbox.setName(this.name + "area");

		this.onBlur = "chkHomePhone(" + this.name + "area" + "," + this.name
				+ "_view," + this.name + ");";
		lbox.setValidCode("TELAREA");
		lbox.setonChange("chkHomePhone(this," + this.name + "_view,"
				+ this.name + ");");
		String xValue = this.value;

		if (this.value.indexOf("02") == 0) {
			lbox.setChecked("02");
			xValue = xValue.substring(2);
		} else {
			if ((!this.value.equals("")) && (this.value.charAt(0) == '#')) {
				if (xValue.length() > 1)
					xValue = xValue.substring(1);
				lbox.setChecked("#");
			} else if (this.value.length() > 3) {
				if (xValue.length() > 3)
					xValue = xValue.substring(3);
				lbox.setChecked(this.value.substring(0, 3));
			}
		}
		lbox.ini();

		tagInput = lbox.getInput()
				+ " <input type=\"text\" "
				+ " name=\""
				+ this.name
				+ "_view\""
				+ " size=\""
				+ this.charsize
				+ "\"" //  9 ѡ => 02 9999999  099 999999
				+ " maxlength=\""
				+ this.maxsize
				+ "\""
				+ " value=\""
				+ xValue
				+ "\""
				+ ((this.disable.equalsIgnoreCase("true")) ? " disabled" : "")
				+ ((this.readonly.equalsIgnoreCase("true")) ? " readonly " : "")
				+ " onClick=\"" + onClick + "\"" + " onChange=\"" + onChange
				+ "sysIsEdit();" + "\"" + " onMouseOver=\"" + this.onMouseOver
				+ "\"" + " onMouseOut=\"" + this.onMouseOut + "\""
				+ " onKeyPress=\"" + this.onKeyPress + "\"" + " onKeyUp=\""
				+ this.onKeyUp + "\"" + " dir=\"" + dir + "\"" + " onBlur=\""
				+ this.onBlur + "\"" + " onFocus=\"" + this.onFocus + "\""
				+ " alt=\"" + ((com != null) ? com.getAlt() : "") + "\""
				+ "  >" + label2;
	}

}
