package com.csc.library.cscimport;


import java.util.Hashtable;

public class ProcessLineList extends ProcessBase implements RecordSet {
	private int dataSize = 0;
	private Hashtable config;

	public ProcessLineList(String fName) {
		super(fName);
		config = new Hashtable();
	}

	public void set(String key, String value) {
		this.config.put(key, value);
	}

	public void setObject(String key, Object value) {
		this.config.put(key, value);
	}

	public void setInt(String key, int value) {
		this.config.put(key, new Integer(value));
	}

	public Object get(String key) {
		return this.config.get(key);
	}

	public int getInt(String key) {
		Integer tmpInt = (Integer) config.get(key);
		return tmpInt.intValue();
	}

	public String getString(String key) {
		return config.get(key).toString();
	}

	public String next() {
		return readFile.getStringRL(); //get String 1 line into String tmpStr
	}

	public boolean hasMoreElement() {
		return this.readFile.hasMoreData();
	}
}