package com.csc.library.database;


public class FieldBoolean extends MyField {
	public FieldBoolean(String name) {
		super(name);
		this.setDefault("true");
		//    this.type = "Boolean";
	}

	public FieldBoolean(String name, String description) {
		super(name, description);
		this.setDefault("true");
		//    this.type = "Boolean";
	}

	public FieldBoolean(String name, int width, String description) {
		super(name, width, description);
		this.setDefault("true");
		//    this.type = "Boolean";
	}

	public FieldBoolean(String name, int width, int decimal, String description) {
		super(name, width, decimal, description);
		this.setDefault("true");
		//    this.type = "Boolean";
	}

	public FieldBoolean(String name, Integer width, Integer decimal, String description) {
		this(name, width.intValue(), decimal.intValue(), description);

	}

	public String getCompareString() {
		return this.getName() + "=" + this.getValueString();
	}

	public String getValueString() {
		return "'" + this.getString() + "'";
	}

	public String getFieldCreate() {
		return this.getName() + " CHAR";
	}
	public String getSaveString() {
		if(this.isEncrypt())
			return this.encryption();
		else	
			return  String.valueOf(this.getBoolean());
	}	
	
}
