package com.csc.library.database;

import java.text.DecimalFormat;
import java.text.ParseException;

import org.apache.commons.lang.StringUtils;
import com.csc.library.utilities.MyLog;

public class FieldDouble extends MyField {
	public FieldDouble(String name) {
		super(name);
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";
		//    this.type = "Double";
	}
	public FieldDouble(String name, String description) {
		super(name, description);
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";
		///   this.type = "Double";
	}
	public FieldDouble(String name, int width, String description) {
		super(name, width, description);
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";
		//    this.type = "Double";
	}
	public FieldDouble(String name, int width, int decimal, String description) {
		super(name, width, decimal, description);
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";
		//   this.type = "Double";
	}
	public FieldDouble(String name, Integer width, Integer decimal, String description) {
		this(name, width.intValue(), decimal.intValue(), description);
	}
	/**
	 *  Encryption Data
	 */
	public String getCompareString() {
		return this.getName() + "=" + this.encryption();
	}
	public String getValueString() {
		return this.getString();
	}
	/*
	public boolean set(String x) {
		if (x.equals("")) {
			return this.set(0);
		} else if (x.indexOf(".") == -1) {
			return this.set(Integer.parseInt(x));
		} else {
			return this.set(Double.parseDouble(x));
		}
	}
	*/
	public String getFieldCreate() {
		return this.getName() + " DECIMAL(" + String.valueOf(this.getWidth()) + "," + String.valueOf(this.getDecimal()) + ")";
	}
	public String getSaveString() {
		String data=""; 
		if (this.isEncrypt()) {
			data = this.encryption();
		} else {
			DecimalFormat dc = new DecimalFormat("##########0.00##");
			data= dc.format(this.getDouble());
		}
		return data;
	}
	/*  public String getProperty(String code) { //getProperty
	 try {
	 if(code.equalsIgnoreCase("value")){
	 String data=super.getProperty(code);
	 java.text.DecimalFormat dc=new  java.text.DecimalFormat();
	 dc.applyPattern("#.##");
	 return dc.format(Double.parseDouble(data));
	 }else{
	 return super.getProperty(code);
	 }
	 } catch (Exception e) {
	 //e.printStackTrace();
	 return "0";
	 }
	 }*/
	/*	public String getProperty(String code) { //getProperty 
	 try { 
	 return super.getProperty(code); 
	 } catch (Exception e) { 
	 //		e.printStackTrace(); 
	 return "0"; 
	 } 
	 }
	 */
	public String getProperty(String code) { //getProperty
		try {
			if (code.equalsIgnoreCase("value")) {
				String data = super.getProperty(code);
				return data;
			} else {
				return super.getProperty(code);
			}
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
			return "0";
		}
	}
	protected String getFormatValue(String format, String value) {
		DecimalFormat dc = new DecimalFormat();
		dc.applyPattern(format);
		if(this.isEncrypt()){
			String temp=value;
			temp=(temp.indexOf(",")!=-1)?temp.replace(",",""):temp;
			//Fix Bug No comment Some time encrpyt data in wel format
//			try {
//				value = dc.format(Double.parseDouble(this.decryption(value)));
//			} catch (Exception e) {
				value=dc.format(Double.parseDouble(temp));
//			}
		}else{
			value=(value.indexOf(",")!=-1)?value.replace(",",""):value;
			value = dc.format(Double.parseDouble(value));
		}
		return value;
	}
	
	protected String getParseValue(String format, String value) {
		format = StringUtils.trimToNull(format);
		try {
			if ( format != null ) {
				value = value.replace(",", "");
				DecimalFormat dc = new DecimalFormat();
				dc.applyPattern(format);
				value = String.valueOf(dc.parse(value));
			}
		} catch (ParseException e) {
        	MyLog.error(this, this.getUProfile(), this.getName()+"["+format+"]["+value+"]------> "+e);
		}
		return value;
	}
	
	public String getString(String fieldname) {
		String buff = super.getString();
		if ( StringUtils.isBlank(buff)) {
			buff = "0";
		}
		return buff;
	}
}
