package com.csc.library.database;

import com.csc.library.utilities.CscCalendar;
public class GenCompareString {

        //String dateType = "YMD"; //edit by pae 8-12-47
	String dateType = "DMY";
	String DataBase = "MYSQL";

	public String generate(String name, FieldDate f) {
		return name + "=" + genSQLDate(dateString(f.getcscCalendar()));
	}

	public String generate(String name, FieldTime f) {
		return name + "=" + f.getValueString();
	}



	public String generate(String name, FieldTimeStamp f) {
		return name + "=" + f.getValueString();
	}

	public String generate(String name, CscCalendar d) {
		String s = name + "=" + genSQLDate(dateString(d));
		return s;
	}

	public String generate(String name, String sign, CscCalendar d) {
		return name + sign + genSQLDate(dateString(d));
	}

	public String generate(String name, String sign, String value) {
		return name + sign + "'" + value + "'";
	}

	public String generate(String name, String value) {
		return name + "=" + "'" + value + "'";
	}

	public String generate(FieldDate f) {
		//this.logger.info("in fieldDate");
		//this.logger.info("dateString(f.getcscCalendar()) ="+dateString(f.getcscCalendar()));
		return genSQLDate(dateString(f.getcscCalendar()));
	}

	public String generate(FieldTime f) {
		return "'" + f.getString() + "'";
	}

	public String generate(FieldTimeStamp f) {
		String s;
		if (DataBase.equals("ACCESS")) {
			s = "'" + f.getString().substring(0, 10) + "'";
		} else {
			s = "'" + f.getString() + "'";
		}
		return s;
	}

	public String generate(CscCalendar d) {
		return genSQLDate(dateString(d));
	}

	public static String generate(String value) {
		return "'" + value + "'";
	}

	public String dateString(CscCalendar d) {
		//System.out.println("DDDDDDDDDDDDDDDDDDDDDDDDDD "+d.getTimestamp());
		if (dateType.equals("DMY")) {
			return d.getDDMMYYYY();
		} else {
			if (dateType.equals("MDY")) {
				return d.getMMDDYYYY();
			} else {
				return d.getYYYYMMDD();
			}
		}
	}

        private String genSQLDate(String d) {
                String s;
                if (DataBase.equals("mySQL"))
                        s = "'" + d.replace('/', '-') + "'";
                else {
                        if (!DataBase.equals("ORACLE")) {
                                s = "'" + d.replace('/', '-').substring(0, 10) + "'";
                        } else {
                                s = "CTOD('" + d + "')";
                        }
                }
                return s;
        }


}
