package com.csc.library.database;
import java.util.Iterator;

import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.session.RecordCmp0;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;
/**
 * @author developer11
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class SimRecord extends RecordCmp0 {
	public boolean simWorking = false;
	private MyHashMap hTable;
	public SimRecord(String a, String b) {
		super(a, b);
		hTable = new MyHashMap(true);
	}
	public SimRecord(String a, String b, boolean c) {
		super(a, b);
		hTable = new MyHashMap(true);
		this.simWorking = c;
	}
	
	public FieldManager getSimField(String table, String fieldName) {
		try {				
			MyHashMap hRecNo = (MyHashMap) this.hTable.get(table);
			MyHashMap hField = (MyHashMap) hRecNo.get("0");
			return (FieldManager) hField.get(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"table : " + table + " field : " + fieldName);
			MyLog.error(this,  e);
			return null;
		}
	}
	public void clearSimField() {
		try {				
			MyHashMap hRecNo;
			for (Iterator IT = this.hTable.getKeyIterator(); IT.hasNext();) {
				String table = IT.next().toString();
				 hRecNo = (MyHashMap) this.hTable.get(table);
				MyHashMap hField = (MyHashMap) hRecNo.get("0");
				for (Iterator ITF = hField.getKeyIterator(); ITF.hasNext();) {
					String fieldName = ITF.next().toString();
					FieldManager fm = (FieldManager) hField.get(fieldName);
					fm.setDefault();
				}	
			}
		} catch (Exception e) {
			MyLog.error(this,  e);
		}
	}
	public FieldManager getSimField(String table, String key, String fieldName) {
		MyHashMap hRecNo = (MyHashMap) this.hTable.get(table);
		MyHashMap hField = (MyHashMap) hRecNo.get(key);
		return (FieldManager) hField.get(fieldName);
	}
	public MyHashMap getSimRecord(String table) {
		MyHashMap hRecNo = (MyHashMap) this.hTable.get(table);
		return (MyHashMap) hRecNo.get("0");
	}
	public MyHashMap getSimRecord(String table, String key) {
		MyHashMap hRecNo = (MyHashMap) this.hTable.get(table);
		return (MyHashMap) hRecNo.get(key);
	}

	protected DbRecord initRecord(String table) {
		DbRecord rec = new InitialRecord(this.userPro, this.param).getDbRecord(table);
		try {
			rec.setProperties(true);
		} catch (Exception ex) {
			MyLog.error(this, ex);
		}
		return rec;
	}
	public Iterator getFieldSimListKey(String table) {
		MyHashMap hRecNo = (MyHashMap) this.hTable.get(table);
		MyHashMap hField = (MyHashMap) hRecNo.get("0");
		return hField.keySet().iterator();
	}
	public Iterator getFieldSimListKey(String table, String key) {
		MyHashMap hRecNo = (MyHashMap) this.hTable.get(table);
		MyHashMap hField = (MyHashMap) hRecNo.get(key);
		return hField.keySet().iterator();
	}
	public Iterator getSimListKey(String table) {
		MyHashMap hRecNo = (MyHashMap) this.hTable.get(table);
		return hRecNo.keySet().iterator();
	}
	public Iterator getSimTableAll() {
		Iterator it = this.hTable.keySet().iterator();
		return this.hTable.keySet().iterator();
	}
	public FieldManager getField(String fieldName) {
		String tName, kName, fName, tmpStr;
		FieldManager fm = super.getField(fieldName);
		if (this.simWorking == true) {
			try {
				if (fm == null) {
					if (fieldName.indexOf("$") >= 0) {
						tName = fieldName.substring(0, fieldName.indexOf("$"));
						tmpStr = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
						if (tmpStr.indexOf("$") >= 0) {
							kName = tmpStr.substring(0, tmpStr.indexOf("$"));
							fName = tmpStr.substring(tmpStr.indexOf("$") + 1, tmpStr.length());
							fm = this.getSimField(tName, kName, fName);
						} else {
							fName = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
							fm = this.getSimField(tName, fName);
							//System.out.println("fieldName <"+fieldName+">fm---->"+fm.getName()+"<-----"+fm.getString());
						}
					} else if (fieldName.indexOf(".") >= 0) {
						tName = fieldName.substring(0, fieldName.indexOf("."));
						tmpStr = fieldName.substring(fieldName.indexOf(".") + 1, fieldName.length());
						if (tmpStr.indexOf(".") >= 0) {
							kName = tmpStr.substring(0, tmpStr.indexOf("."));
							fName = tmpStr.substring(tmpStr.indexOf(".") + 1, tmpStr.length());
							fm = this.getSimField(tName, kName, fName);
						} else {
							fName = fieldName.substring(fieldName.indexOf(".") + 1, fieldName.length());
							fm = this.getSimField(tName, fName);
							//System.out.println("fieldName <"+fieldName+">fm---->"+fm.getName()+"<-----"+fm.getString());
						}
					}
				}

					
			} catch (Exception e) {
				MyLog.error(this, e);
			}
		}
		return fm;
	}
	
//	public FieldManager getField(int index) {
//		String tName, kName, fName, tmpStr,fieldName;
//		FieldManager fm = super.getField(index);
//		fieldName=fm.getName();
//		if (this.simWorking == true) {
//			try {
//				if (fm == null) {
//					if (fieldName.indexOf("$") >= 0) {
//						tName = fieldName.substring(0, fieldName.indexOf("$"));
//						tmpStr = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
//						if (tmpStr.indexOf("$") >= 0) {
//							kName = tmpStr.substring(0, tmpStr.indexOf("$"));
//							fName = tmpStr.substring(tmpStr.indexOf("$") + 1, tmpStr.length());
//							fm = this.getSimField(tName, kName, fName);
//						} else {
//							fName = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
//							fm = this.getSimField(tName, fName);
//							//System.out.println("fieldName <"+fieldName+">fm---->"+fm.getName()+"<-----"+fm.getString());
//						}
//					} else if (fieldName.indexOf(".") >= 0) {
//						tName = fieldName.substring(0, fieldName.indexOf("."));
//						tmpStr = fieldName.substring(fieldName.indexOf(".") + 1, fieldName.length());
//						if (tmpStr.indexOf(".") >= 0) {
//							kName = tmpStr.substring(0, tmpStr.indexOf("."));
//							fName = tmpStr.substring(tmpStr.indexOf(".") + 1, tmpStr.length());
//							fm = this.getSimField(tName, kName, fName);
//						} else {
//							fName = fieldName.substring(fieldName.indexOf(".") + 1, fieldName.length());
//							fm = this.getSimField(tName, fName);
//							//System.out.println("fieldName <"+fieldName+">fm---->"+fm.getName()+"<-----"+fm.getString());
//						}
//					}
//				}
//
//					
//			} catch (Exception e) {
//				MyLog.error(this, e);
//			}
//		}
//		return fm;
//	}
	
	public void removeSimTable(String tableName) {
		String keyName, fieldName;
		Iterator iKey = this.getSimListKey(tableName);
		MyHashMap hRecNo = (MyHashMap) this.hTable.get(tableName);
		while (iKey.hasNext()) {
			keyName = iKey.next().toString();
			Iterator iField = this.getFieldSimListKey(tableName, keyName);
			MyHashMap hField = (MyHashMap) hRecNo.get(keyName);
			MyHashMap tmphField = (MyHashMap) hField.clone();
			while (iField.hasNext()) {
				fieldName = iField.next().toString();
				tmphField.remove(fieldName);
			}
			hField = tmphField;
			hRecNo.remove(keyName);
		}
		this.hTable.remove(tableName);
	}
	public void getFileSimList() {
		Iterator itable = this.getSimTableAll();
		while (itable.hasNext()) {
			String table = itable.next().toString();
			Iterator irec = this.getSimListKey(table);
			while (irec.hasNext()) {
				String rec = irec.next().toString();
				Iterator ifield = this.getFieldSimListKey(table, rec);
				while (ifield.hasNext()) {
					String field = ifield.next().toString();
				}
			}
		}
	}
	public boolean set(String fieldName, String data) {
		boolean st=super.set(fieldName, data);
		if(!st){
				try {
					FieldManager fm = this.getField(fieldName);
					if(fm!=null){
						fm.set(data);
						return true;
					}
				}catch(Exception ex){}
		}
		return st;
	}
	public MyHashMap getHTable() {
		return hTable;
	}
	public void setHTable(MyHashMap table) {
		hTable = table;
	}
	
	@Override
	public DbRecord clone(UProfile upf) {
		RecordCmp rc=(RecordCmp)super.clone(upf);
		rc.setHTable(new MyHashMap(true));
		return (DbRecord)rc;
	}
	
	
}
