package com.csc.library.database;

import java.util.Iterator;
import java.util.Vector;

import com.csc.library.session.DbRecord;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class VPropertyRec extends Vector {
	/**
	 * Constructor for PropertyRec.
	 */
	private UProfile user = null;
	private Vector fieldName=new Vector();
	public void setUProfile(UProfile up) {
		this.user = up;
	}
	public UProfile getUProfile() {
		return user;
	}	
	
	private boolean check;
	public VPropertyRec() {
		super();
		this.check = false;
	}
	public void referLangOn() {
		this.check = true;
		//System.out.println("--------------------------step On-----------------------");
	}
	public void referLangOff() {
		this.check = false;
		//System.out.println("--------------------------step Off-----------------------");
	}
	private Object check(String key) {
		int point=this.checkPoint(key);
		return this.getField(point);
	}
	
	private Object getField(int point){
		Object obj =null;
		if(point==-1)
			return null;
		try{
		obj = super.get(point);
		
		if (this.getUProfile() == null) {
            MyLog.info(this, this.getUProfile(), "Uprofile  is NULL ");
		}
		if ((obj != null) && (this.check)) {
			String nameClass = obj.getClass().getName();
			nameClass = nameClass.substring(nameClass.lastIndexOf("."));
			if (nameClass.indexOf("Field") >= 0) {
				FieldManager fm;
				fm = (FieldManager) obj;
				if (!fm.getProperty("REFER_LANG").equals("")) {
					if (this.getUProfile() != null) {
						if ((!this.getUProfile().get("lang").equalsIgnoreCase("eng")) && (fm.getLang()=='E')) {
							int ref=this.checkPoint(fm.getProperty("REFER_LANG").toLowerCase());
							obj = super.get(ref);
						} else {
							if ((this.getUProfile().get("lang").equalsIgnoreCase("eng")) && (fm.getLang()=='T')) {
								int ref=this.checkPoint(fm.getProperty("REFER_LANG").toLowerCase());
								obj = super.get(ref);
							}
						}
					}
				}
			}
		}
		}catch(Exception ex){
			ex.printStackTrace();
		}
		return obj;
	} 
	
	
	public Object get(Object key) {
		return this.check(((String) key).toLowerCase());
	}
	
	public Object get(int key) {
		return this.getField(key);
	}	
	
	public void put(Object key, Object value) {
		if(!this.fieldName.contains((String)key)){
			super.add(value);
			this.fieldName.add(((String)key).toLowerCase());
		}else{
			int point=this.checkPoint(((String)key).toLowerCase());
			if(point>-1){
				super.remove(point);
				super.add(point,value);
			}
		}
			
	}
	
	public VPropertyRec clone(DbRecord db, UProfile upf) {
		VPropertyRec hm = new VPropertyRec();
		hm.setUProfile(upf);
		if(this.check){
			hm.referLangOn();
		}else{
			hm.referLangOff();
		}
		
		for(int i=0;i<this.size();i++) {
			FieldManager fm = (FieldManager)super.get(i);
			fm.setRecord(db);
			fm.initField(upf);
			hm.put(fm.getName().toLowerCase(), fm.clone());
		}	
		return hm; 
	}
	
	public VPropertyRec clone(DbRecord db) {
		VPropertyRec hm =this.clone(db, this.getUProfile());
		return hm; 
	}
	
	public int checkPoint(String key){
		int point=this.fieldName.indexOf(key);
		return point;
	}
	public Vector getFieldName() {
		return fieldName;
	}
	public void setFieldName(Vector fieldName) {
		this.fieldName = fieldName;
	}

	@Override
	public boolean remove(Object o) {
		int point=this.checkPoint(((String)o).toLowerCase());
		boolean b=false;
//		System.out.println("XXXXXXXXXXXXXXXXXXX >>>>>>>> Remove <<<<<<<<<< XXXXXXXXXXXXXXXXX");
		if(point>-1){
//			System.out.println("XXXXXXXXXXXXXXXXXXX >>>>>>>> NAME="+o);
			super.remove(point);
			this.fieldName.remove(point);
			b=true;
		}
		return b;
	}
	
	public boolean containsKey(String key){
//		System.out.println("XXXXXXXXXXXXXXXXXXX >>>>>>>> Containskey <<<<<<<<<< XXXXXXXXXXXXXXXXX");
		if(this.checkPoint(key.toLowerCase())>-1){
			return true;
		}
		return false;
	}
	
}
