package com.csc.library.mail;

import java.util.Properties;

import javax.mail.AuthenticationFailedException;
import javax.mail.Session;
import javax.mail.Store;

import com.csc.library.utilities.MyLog;

public class MailConnect {
	Store store;

	public MailConnect(String Hostname, String Username, String Password) {
		try {
			Properties pro = System.getProperties(); //Get a Properties object
			Session session = Session.getDefaultInstance(pro, null); //Get a Session object
			//      session.setDebug(true);
			store = session.getStore("pop3"); //Get a Store object
			try {
				store.connect(Hostname, 110, Username, Password);
			} catch (AuthenticationFailedException Afe) {
				MyLog.error(this, "Unable to logon host: " + Afe);
			}
		} catch (Exception ex) {
			MyLog.error(this,  ex);
		}
	}

	public Store getStore() {
		return this.store;
	}
}