package com.csc.library.report;
import java.io.File;

import com.csc.library.utilities.MyLog;
import com.inet.report.Engine;
import com.inet.report.RDC;

public class ConvertCrToCc {
	private String crRep, ccRep;
	//transient private Logger logger = Logger.getLogger(ConvertCrToCc.class);

	public ConvertCrToCc(String crRep, String ccRep) {
		this.ccRep = ccRep;
		this.crRep = crRep;
	}
	public ConvertCrToCc() {}
	public String Process() {
		try {
		//	this.logger.info("Convert Crystal Report:" + crRep);
		//	this.logger.info("To Crystal Clear : " + crRep);
			Engine eng = new Engine();
			eng.setReportFile("file:" + crRep);
			Exception[] exceptions = eng.getLoadExceptions();
			if (exceptions != null) {
				for (int i = 0; i < exceptions.length; i++) {
			//		this.logger.fatal("Exception while converting rpt file: " + (exceptions[i]).toString() + "\\n");
				}
			}
			File file = new File(ccRep);
			RDC.saveEngine(file, eng);
		//	this.logger.info("Successfull....");
			return "Successfull....";
		} catch (Throwable t) {
			MyLog.error(this, t.toString());
			return t.toString();
		}
	}
	public String Process(String crRep, String ccRep) {
		this.ccRep = ccRep;
		this.crRep = crRep;
		return this.Process();
	}
}