package com.csc.library.security;
import java.util.HashMap;


import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;
/**
 *
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */
public class AccountSecurity implements Security {
	/**
	 *
	 * @param h
	 * @return
	 * function : create uProfile
	 */
	public UProfile login(HashMap h) {
		UProfile user = new UProfile();
		InitialEnvironment pc = new InitialEnvironment("TT3");
		try {
			//this.logger.info("[ DATABASE NAMME  ]" + pc.getValue("database-name"));
			DbInquiry emp = new InitialInquiry(user).getDbInquiry();
			emp.initMyTable("Memployee", "", "");
			emp.setSchemaName("prtjtt");
			emp.setFilter("fname = '" + (String) h.get("user") + "'");

			////this.logger.info("Security.Login : " + (String) h.get("user"));
			emp.refresh();

			if (emp.next()) {
				if ((emp.getString("lname").equals((String) h.get("password")))) {
					user.set("dbname", "PRDBS10D");
					user.setSchemaName("prtjtt");
					user.set("username", (String) h.get("user"));
					user.set("fullname", emp.getString("fname") + "  " + emp.getString("lname"));
					user.set("password", (String) h.get("password"));
					user.set("employee", emp.getString("employee"));
					user.set("division", emp.getString("division"));
					user.set("section", emp.getString("section"));
					user.set("dept", emp.getString("dept"));
				}
			}
		} catch (Exception e) {
			MyLog.error(this, user, e);
		}
		return user;
	}
	/**
	 *
	 * @param user
	 * @param h
	 * @return
	 * function : check menu group_id with user menu group_id in uProfile
	 */
	public boolean checkmenu(UProfile user, HashMap h) {
		boolean check;
		String menu, strGroupMenu;
		try {
			menu = (String) h.get("menucode");
			strGroupMenu = user.get("menu");
			if (strGroupMenu.indexOf("," + menu + ",") > -1 || menu.equals("")) {
				check = true;
			} else {
				check = false;
			}
		} catch (Throwable e) {
			MyLog.error(this, user, "Error (bgSecurity.login) " +e.toString());
			return false;
		}
		return check;
	}
}