package com.csc.library.session;

import java.lang.reflect.Method;

import javax.naming.Context;
import javax.naming.NamingException;

import com.csc.library.process.DbReport;
import com.csc.library.process.ReportProcess;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class ConnectProcess {

	private Context ctx = null;
	private MyContext con=null;
	public ConnectProcess() {
		con=new MyContext();
	}
	private Object home;
	public Connectable getProcess(String serverUrl) {
		try {
			this.getInitialContext(serverUrl);
			return (Connectable)this.invokeRemote();
		} catch (Exception e) {
//			MyLog.error(this, e);
			return null;
		}
	}

	private void getInitialContext(String serverUrl) throws NamingException {
		con.setProviderUrl(serverUrl);
		ctx = con.getInitialContext();
		home = ctx.lookup("ejb/process/InvokeProcess");
	}

	private Object invokeRemote() throws Exception {
		Class c = home.getClass();
		Method mx = c.getDeclaredMethod("create", new Class[] {});
		return mx.invoke(home, new Object[] {});
	}
}