package com.csc.library.utilities;

import java.util.StringTokenizer;
public class GenListbox {

	String text, delimitor;

	public GenListbox(String str, String dlim) {
		setText(str);
		setDelimitor(dlim);
	}

	public void setText(String str) {
		text = str;
	}

	public void setDelimitor(String dlim) {
		delimitor = dlim;
	}

	public String getSyntax(String Objname, String script) {

		StringTokenizer tk = new StringTokenizer(text, delimitor);
		StringBuffer syntax = new StringBuffer();
		try {
			String str;
			//this.logger.info("[--------- generate select object ----------] ");
			syntax.append("<select name=\"").append(Objname).append("\" onclick=\"").append(script).append("\">");
			while (tk.hasMoreTokens()) {
				str = tk.nextToken();
				syntax
					.append("<option value=\"")
					.append(str.substring(0, str.indexOf(":")))
					.append("\">")
					.append(str.substring(str.indexOf(":") + 1, str.length()))
					.append("</option>");
			}
			syntax.append("</select>");

		} catch (Exception e) {
			MyLog.error(this, "[ Error genListbox.getSyntax ] " + e);
		}
		//this.logger.info("[--------- select object ----------] " + syntax.toString());
		return syntax.toString();
	}
}
