package com.csc.library.utilities;


public class ThaiUtilities {


	public String Unicode2ASCII(String unicode) { // ???? Unicode ???? ASCII
		if (unicode != null) {
			StringBuffer ascii = new StringBuffer(unicode); // ??????????????????????????
			int code;
			for (int i = 0; i < unicode.length(); i++) { // ????????????????????
				code = (int) unicode.charAt(i); // ????????????????????????
				if ((0xE01 <= code) && (code <= 0xE5B)) // ?????????????????????????????? Unicode ???????
					ascii.setCharAt(i, (char) (code - 0xD60)); // ?????????????????????????????? ASCII
			}
			return ascii.toString(); // ???????????????? ??????? String ????????????????
		} else
			return "";
	}

	public String ASCII2Unicode(String ascii) {
		if (ascii != null) {
			StringBuffer unicode = new StringBuffer(ascii);
			int code;
			for (int i = 0; i < ascii.length(); i++) {
				code = (int) ascii.charAt(i);
				if ((0xA1 <= code) && (code <= 0xFB)) // ?????????????????????????????? ASCII ???????
					unicode.setCharAt(i, (char) (code + 0xD60)); // ?????????????????????????????? Unicode
			}
			return unicode.toString(); // ??????????????????????? String ????????????????
		} else
			return "";
	}
	public String[][] Unicode2ASCII(String[][] unicode) {
		String[][] result= unicode;
		String tmp = "";
		for(int i=0;i<unicode.length;i++){
			tmp = this.Unicode2ASCII(unicode[i][1]);
			result[i][1] = tmp;
		}
		return result;
	}

	public String[][] ASCII2Unicode(String[][] ascii) {
		String[][] result= ascii;
		String tmp = "";
		for(int i=0;i<ascii.length;i++){
			tmp = this.ASCII2Unicode(ascii[i][1]);
			result[i][1] = tmp;
		}
		return result;
	}
}
