package com.csc.library.database;

import com.csc.library.utilities.MyLog;

public class FieldFloat extends FieldInteger {
	private static final long serialVersionUID = 1L;

	public FieldFloat(String name) {
		super(name);
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";
		//    this.type = "Float";
	}

	public FieldFloat(String name, String description) {
		super(name, description);
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";
		//    this.type = "Float";
	}

	public FieldFloat(String name, int width, String description) {
		super(name, width, description);
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";
		//    this.type = "Float";
	}

	public FieldFloat(String name, int width, int decimal, String description) {
		super(name, width, decimal, description);
		this.setDefault("0");
		this.setDefault();
		//   this.type = "Float";
	}

	public FieldFloat(String name, Integer width, Integer decimal, String description) {
		this(name, width.intValue(), decimal.intValue(), description);
	}

	/**
	 *  Encryption Data
	 */
	public String getCompareString() {
		return this.getName() + "=" + this.encryption();
	}

	public String getValueString() {
		return this.getString();
	}

	public boolean set(String x) {
		if (x.equals("")) {
			return this.set(0);
		} else if (x.indexOf(".") == -1) {
			return this.set(Integer.parseInt(x));
		} else {
			return this.set(Double.parseDouble(x));
		}
	}

	public String getFieldCreate() {
		return this.getName() + " DECIMAL(" + String.valueOf(this.getWidth()) + "," + String.valueOf(this.getDecimal()) + ")";
	}
	public String getSaveString() {
		if(this.isEncrypt())
			return this.encryption();
		else
			return  String.valueOf(this.getFloat());
	}
       /* public String getProperty(String code) { //getProperty
        try {
                        if(code.equalsIgnoreCase("value")){
                          String data=super.getProperty(code);
                          java.text.DecimalFormat dc=new  java.text.DecimalFormat();
                          dc.applyPattern("#.##");
                          return dc.format(Double.parseDouble(data));
                        }else{
                          return super.getProperty(code);
                        }
                } catch (Exception e) {
                        //e.printStackTrace();
                        return "0";
                }
      }*/

	  public String getProperty(String code) { //getProperty
        try {
			if(code.equalsIgnoreCase("value")){
			  String data=super.getProperty(code);
			  java.text.DecimalFormat dc=new  java.text.DecimalFormat();
			  dc.applyPattern("0.00");
			  return dc.format(Double.parseDouble(data));
			}else{
			  return super.getProperty(code);
			}
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
			return "0";
		}
      }


}
