package com.csc.library.database;

import java.rmi.Remote;
import java.rmi.RemoteException;

public interface GroupManager extends Remote {
	public int delete() throws RemoteException;
	public int save() throws RemoteException;
	public int print() throws RemoteException;
	public int list() throws RemoteException;
	public int setFilter() throws RemoteException;
	public int refresh() throws RemoteException;
	public int addNew() throws RemoteException;
	public int insert() throws RemoteException;

	public int recCount() throws RemoteException;
	public int next() throws RemoteException;
	public int previous() throws RemoteException;
	public int recNo() throws RemoteException;
	public int go(int nRec) throws RemoteException;

	public int setColumn(String ColumnList) throws RemoteException;
	public String getError() throws RemoteException;
	public void restore() throws RemoteException;
	public String workingField() throws RemoteException;

	public int delete(String table) throws RemoteException;
	public int deleteAll(String table) throws RemoteException;
	public int save(String table) throws RemoteException;
	public int print(String table) throws RemoteException;
	public int list(String table) throws RemoteException;
	public int setFilter(String table) throws RemoteException;
	public int refresh(String table) throws RemoteException;
	public int next(String table) throws RemoteException;
	public int previous(String table) throws RemoteException;
	public int addNew(String table) throws RemoteException;
	public int recCount(String table) throws RemoteException;
	public int recNo(String table) throws RemoteException;
	public int go(String table, int nRec) throws RemoteException;
	public int insert(String table) throws RemoteException;
	public int setColumn(String table, String ColumnList) throws RemoteException;
	public void clearField(String table) throws RemoteException;
	public void restore(String table) throws RemoteException;
}