package com.csc.library.database;

import java.io.File;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.Vector;

import org.jdom.Attribute;
import org.jdom.Element;

import com.csc.library.session.InitialEnvironment;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadXml;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */
public class LoadProTableV2 {
	private HashMap				fieldPro	= new HashMap();
	private HashMap				relation	= new HashMap();
	private HashMap				fieldGroup	= new HashMap();
	private String				descEng, descThai, editcheck = "false";
	private String				fileName;
	private String				verify, verifyGroup;
	//private String mainHelp,referHelp,mainKey,securityClass;
	private String				mainHelp, referHelp, mainKey;
	//transient private Logger	logger		= Logger.getLogger(LoadProTableV2.class);
	boolean						loadCompo	= false;
	private String				wfactive	= "false";
	private String				wfkey		= "";
	private String				documentno 	= "";
	private String				security;
	private Vector				systemField	= new Vector();
	// depend on all table
	private String 				tdbintegrity = "false";
	private String 				deleteFlag ="true";
	private String 				configName="";
	private HashMap				aliasname=null;
	private Vector				maindatoryField = new Vector();
	private Vector				fieldBlob = new Vector();
	private Vector			    filedUpload = new Vector<String>();
	private PropertyRec			keyField = new PropertyRec();
	private Vector				allFieldName = new Vector();
	//and condition beforesave && orconditionbeforesave
	private Vector andCondition	=	new Vector();
	private Vector orCondition	=	new Vector();
	private Vector columnNeed	=	new Vector();

	/**
	 * @return Returns the configName.
	 */
	public String getConfigName() {
		return configName.toUpperCase();
	}
	public String getSecurity() {
		return this.security;
	}
	public HashMap getProperties() {
		return fieldPro;
	}
	public void setTableName(String table) {
		this.fileName = table;
	}
	private String getPath() {
		String path = "";
		try {
			path = new InitialEnvironment("GLOBAL").getValue("xmlpath-protable");
//			path="D:/EnterprisePT/CompareProdb/NEW/";
		} catch (Exception ex) {
        	MyLog.error(this, "Can not get path to load config server file.");
		}
		return path;
	}
	public void process() {
		try {
			
			String sField="";
			ReadXml read = new ReadXml();
			read.setDataManager(this.getPath() + this.fileName);
			Element root = read.getRootElement();
			this.security = root.getAttributeValue("security");
			descThai = root.getAttributeValue("desc_thai").trim();
			descEng = root.getAttributeValue("desc_eng").trim();
			this.mainHelp = root.getAttributeValue("mainhelp");
			String wfactive = root.getAttributeValue("wfactive");
			if (wfactive != null && wfactive.equals("true")) {
				this.wfactive = "true";
			} else
				this.wfactive = "false";
			this.wfkey = root.getAttributeValue("wfkey");
			if (this.wfkey == null)
				this.wfkey = "";
			this.documentno = root.getAttributeValue("documentno");
			if (this.documentno == null) 
				this.documentno = "";
			this.configName = root.getAttributeValue("config_field");
			if (this.configName == null) 
				this.configName = "";						
			// load systemfield
			sField = root.getAttributeValue("fieldsystem");
			if (sField != null&& sField.trim().length()>0){
				StringTokenizer stn = new StringTokenizer(sField, ",");
				while (stn.hasMoreTokens()) {
					String fName = stn.nextToken();
					systemField.add(fName.toLowerCase().trim());
				}
			}else{
				systemField.add("NONE");
			}
			//set Delete flag
			deleteFlag=root.getAttributeValue("deleteflag");
			if(deleteFlag==null){
				deleteFlag="false";
			}		
			// set table depend 
			if (root.getAttributeValue("dependlevel") != null)
				this.tdbintegrity = root.getAttributeValue("dependlevel");
			this.referHelp = root.getAttributeValue("referhelp");
			this.mainKey = root.getAttributeValue("mainkey");
			this.editcheck = root.getAttributeValue("editcheck").trim();
			
			// modified by pas 20080226
			if(root.getAttributeValue("andconditionbeforesave")!=null && root.getAttributeValue("andconditionbeforesave").length()>0){
				String[] tmp=root.getAttributeValue("andconditionbeforesave").split(",");
				for(int t=0;t<tmp.length;t++){
					andCondition.addElement(tmp[t].toLowerCase());
				}
			}
			if(root.getAttributeValue("orconditionbeforesave")!=null && root.getAttributeValue("orconditionbeforesave").length()>0){
				String[] tmp=root.getAttributeValue("orconditionbeforesave").split(",");
				for(int t=0;t<tmp.length;t++){
					orCondition.addElement(tmp[t].toLowerCase());
				}
			}
			// end modified by pas 20080226
			
			//modified by pas 20080316
			
			if(root.getAttributeValue("column_need")!=null && root.getAttributeValue("column_need").length()>0){
				String[] tmp=root.getAttributeValue("column_need").split(",");
				for(int t=0;t<tmp.length;t++){
					columnNeed.addElement(tmp[t].toLowerCase());
				}
			}
			
			//end of midified by pas 20080316
				
			List list = root.getChild("FIELD").getChildren();			
			Iterator it = list.iterator();
			String fieldName = "";
			while (it.hasNext()) {
				Element obj = (Element) it.next();
				if (obj != null) {
					fieldName = obj.getName();
//					this.logger.info("LOAD ELEMENT : "+fieldName);
					if ((fieldName != null) && (!fieldName.equals(""))) {
						fieldName = fieldName.toLowerCase();
					}
					if(!systemField.contains(fieldName)) {
						this.allFieldName.add(fieldName);
						HashMap h = this.getProField(obj);
						this.fieldPro.put(fieldName, h);
						if (h.containsKey("KEY") ) { 
							//  h.containsKey("REFER_DATA") Ѵ͡Ҩзҹµ͹ save 
							// ˹Ҩʹѧ鹵͹ҧŨҡ Refer ͧ Field ú¶ըջѭ save ú
							this.maindatoryField.addElement(fieldName);
							this.keyField.put((String)h.get("KEY"),fieldName);
						}
						if(h.containsKey("UPLOAD")){
							this.filedUpload.add(fieldName);
						}
					}	
					fieldName = "";
				}
			}
			this.setRelation(root.getChild("RELATION"));
		} catch (Exception e) {
			MyLog.error("Error on PROTABLEXML/".concat(this.fileName).concat(".xml"));
        	MyLog.error(this, e);
		}
	}

	public void processDiff() {
		try {
			String sField="";
			ReadXml read = new ReadXml();
			ReadXml readdiff = new ReadXml();
			read.setDataManager(this.getPath() + this.fileName);
			Element root = read.getRootElement();
			Element rootdiff=null;
			File file=new File(this.getPath() +"DIFFXML/"+ this.fileName+".xml");
			if(file.isFile()){
				readdiff.setDataManager(this.getPath() +"DIFFXML/"+ this.fileName);
				rootdiff= readdiff.getRootElement();
			}
			if(rootdiff!=null){
					this.security = root.getAttributeValue("security");
					descThai = root.getAttributeValue("desc_thai").trim();
					descEng = root.getAttributeValue("desc_eng").trim();			
					this.mainHelp = root.getAttributeValue("mainhelp");
					String wfactive = root.getAttributeValue("wfactive");
					if (wfactive != null && wfactive.equals("true")) {
						this.wfactive = "true";
					} else
						this.wfactive = "false";
					this.wfkey = root.getAttributeValue("wfkey");
					if (this.wfkey == null)
						this.wfkey = "";
					this.documentno = root.getAttributeValue("documentno");
					if (this.documentno == null) 
						this.documentno = "";
					this.configName = root.getAttributeValue("config_field");
					if (this.configName == null) 
						this.configName = "";						
					// load systemfield
					sField = root.getAttributeValue("fieldsystem");
					if (sField != null&& sField.trim().length()>0){
						StringTokenizer stn = new StringTokenizer(sField, ",");
						while (stn.hasMoreTokens()) {
							String fName = stn.nextToken();
							systemField.add(fName.toLowerCase().trim());
						}
					}else{
						systemField.add("NONE");
					}
					//set Delete flag
					deleteFlag=root.getAttributeValue("deleteflag");
					if(deleteFlag==null){
						deleteFlag="false";
					}		
					// set table depend 
					if (root.getAttributeValue("dependlevel") != null)
						this.tdbintegrity = root.getAttributeValue("dependlevel");
					this.referHelp = root.getAttributeValue("referhelp");
					this.mainKey = root.getAttributeValue("mainkey");
					this.editcheck = root.getAttributeValue("editcheck").trim();
					List list = root.getChild("FIELD").getChildren();
					Element emchild=rootdiff;
					this.setRelation(root.getChild("RELATION"));
					Iterator it = list.iterator();
					String fieldName = "";
					while (it.hasNext()) {
						Element obj = (Element) it.next();
						if (obj != null) {
							fieldName = obj.getName();
		//					this.logger.info("LOAD ELEMENT : "+fieldName);
							if ((fieldName != null) && (!fieldName.equals(""))) {
								fieldName = fieldName.toLowerCase();
							}
							if(!systemField.contains(fieldName)){
								if(emchild!=null)
									this.fieldPro.put(fieldName, this.getProFieldDiff(obj,emchild.getChild(fieldName.toUpperCase())));
								else
									this.fieldPro.put(fieldName,this.getProField(obj));
							}
							fieldName = "";
						}
					}
			}else{
				this.process();
			}	
		} catch (Exception e) {
        	MyLog.error(this, e);
		}
	}
	
	private void setRelation(Element objRela) {
		if(objRela!=null){
		List list = objRela.getChildren();
		Iterator it = list.iterator();
		Element rela, subRela;
		Iterator itChild;
		List listChild;
		Vector child, parent;
		HashMap hRela;
		String re = "", ch = "", pa = "";
		while (it.hasNext()) {
			rela = (Element) it.next();
			listChild = rela.getChildren();
			itChild = listChild.iterator();
			parent = new Vector();
			child = new Vector();
			hRela = new HashMap();
			while (itChild.hasNext()) {
				subRela = (Element) itChild.next();
				if (subRela.getName().equalsIgnoreCase("PARENT")) {
					pa = subRela.getText();
					pa = pa.trim().toLowerCase();
					parent.add(pa);
				} else {
					if (subRela.getName().equalsIgnoreCase("CHILD")) {
						ch = subRela.getText();
						ch = ch.trim().toLowerCase();
						child.add(ch);
					}
				}
			}
			hRela.put("PARENT", parent);
			hRela.put("CHILD", child);	
			
			String iLevel = StaticProperties.defaultInsertRelatoinLevel;
			String dLevel = StaticProperties.defaultDeleteRelatoinLevel;
			String iMode  = StaticProperties.defaultMode;
			if (rela.getAttributeValue("insertlevel") != null)
				iLevel = rela.getAttributeValue("insertlevel");
			if (rela.getAttributeValue("deletelevel") != null)
				dLevel = rela.getAttributeValue("deletelevel");
			if (rela.getAttributeValue("mode") != null)
				iMode = rela.getAttributeValue("mode");			
			// get depend from relation to set in relation property
			// -----------------------------
			String delevel = rela.getAttributeValue("dependlevel");
			if (delevel != null)
				hRela.put("DEPENDLEVEL",delevel);
			else 
				hRela.put("DEPENDLEVEL",this.tdbintegrity);

			
			String relaTablename = rela.getAttributeValue("rtablename");
			if (relaTablename != null) 
				relaTablename=this.getTableName(relaTablename);
			else
				relaTablename=this.getTableName(rela.getName());
			
			hRela.put("RTABLENAME",relaTablename);			
			// ------------------------------
			hRela.put("INSERTLEVEL", iLevel);
			hRela.put("DELETELEVEL", dLevel);
			hRela.put("MODE", iMode);
			String moduledelete = "";
			if (rela.getAttributeValue("moduledelete") != null)
				moduledelete = rela.getAttributeValue("moduledelete");
			hRela.put("MODULEDELETE",moduledelete);
			re = rela.getName();
			re = re.trim().toLowerCase();
			this.relation.put(re, hRela);
			/**
			 * setRelationPools
			 */
			//System.out.println("FIleName : "+fileName);
			StaticProperties.relationPools.setRelation(fileName,re ,parent, child,hRela,(Vector)this.maindatoryField.clone());
			/**
			 * end setRelationPools
			 */
			
		}
	 }else{
		 System.out.println("[ERROR ] !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Not Found RELATION Tag ,Please insert Relation tag in "+fileName);
		 }
	}
	
	private HashMap getProField(Element objField) {
		HashMap hashField = new HashMap();
		String fieldName = "";
		fieldName = objField.getName();
		if ((fieldName != null) && (!fieldName.equals(""))) {
			fieldName = fieldName.trim().toLowerCase();
		}
		hashField.put("NAME", fieldName);
//		System.out.print("FieldName : "+fieldName);
		Iterator it = objField.getAttributes().iterator();
		Iterator it2;
		Attribute att;
		while (it.hasNext()) {
			att = (Attribute) it.next();
//			this.logger.debug("att name -->"+att.getName()+"<-- value-->"+att.getValue()+"<----");
//			System.out.print(" "+att.getName()+"="+att.getValue());
			hashField.put(att.getName().toUpperCase(), att.getValue());
			if(att.getName().toUpperCase().equals("TYPE")&&att.getValue().equals("Blob")){
				if(!StaticProperties.blobField.contains(fileName.toLowerCase()+"."+fieldName)){
					StaticProperties.blobField.add(fileName.toLowerCase()+"."+fieldName);
				}
				fieldBlob.add(fieldName);
			}
		}
//		System.out.println();
		List list = objField.getChildren();
		it = list.iterator();
		Element subE = null;
		while (it.hasNext()) {
			subE = (Element) it.next();
			if(!subE.getName().equalsIgnoreCase("APPNAME")){
//				System.out.println("<"+subE.getName()+"="+subE.getText().trim()+">");
				if(subE.getName().equalsIgnoreCase("ALIASNAME")) {
					this.setAliasField(fieldName, subE.getText());
				}
										
				if(subE.getName().equalsIgnoreCase("GROUP")){
					this.setGroupField(fieldName, subE.getText());
				}
				
				// component ->> alt
				if (this.loadCompo && subE.getName().equalsIgnoreCase("COMPONENT")) {
					hashField.put("COMTYPE", subE.getAttributeValue("type").trim());
					list = subE.getChildren();
					it2 = list.iterator();
					Element subCom;
					while (it2.hasNext()) {
						subCom = (Element) it2.next();
//						System.out.println("\t\t"+subCom.getName()+"="+subCom.getText()+"");
//						if(!subCom.getName().equalsIgnoreCase("REQUIRE"))
						hashField.put(subCom.getName(), subCom.getText().trim());
					}
				}			
				hashField.put(subE.getName(), subE.getText());
			}
		}
		// TODO set label properties
		Map<String,String> labelMap = StaticProperties.FIELD_LABEL_CONFIG.getFieldProperties(fileName, fieldName);
		if(labelMap != null) {
			hashField.putAll(labelMap);
		}
		
		ComponentField cf = new ComponentField(objField);
		cf.setLabelMap(labelMap);
		hashField.put("cfield",cf);
		this.fieldGroup.put("all", "*");
		return hashField;
	}

	private HashMap getProFieldDiff(Element objField,Element emchild) {
		HashMap hashField = new HashMap();
		String fieldName = "";
		fieldName = objField.getName();
		if ((fieldName != null) && (!fieldName.equals(""))) {
			fieldName = fieldName.trim().toLowerCase();
		}
		hashField.put("NAME", fieldName);
		Iterator it = objField.getAttributes().iterator();
		Iterator it2;
		Attribute att;
		while (it.hasNext()) {
			att = (Attribute) it.next();
			if(emchild!=null && emchild.getAttribute(att.getName())!=null){
				hashField.put(att.getName().toUpperCase(), emchild.getAttributeValue(att.getName()));
			}else{
				hashField.put(att.getName().toUpperCase(), att.getValue());
			}
		}
		List list = objField.getChildren();
		it = list.iterator();
		Element subE = null;
		while (it.hasNext()) {
			subE = (Element) it.next();
			if(!subE.getName().equalsIgnoreCase("APPNAME")){
				if(subE.getName().equalsIgnoreCase("ALIASNAME"))
					this.setAliasField(fieldName, subE.getText());		
				
				if(subE.getName().equalsIgnoreCase("GROUP"))
					this.setGroupField(fieldName, subE.getText());

				if (this.loadCompo && subE.getName().equalsIgnoreCase("COMPONENT")) {
					if(emchild!=null&& emchild.getChild("COMPONENT")!=null && emchild.getChild("COMPONENT").getAttribute("type")!=null){
						hashField.put("COMTYPE", emchild.getChild("COMPONENT").getAttributeValue("type").trim());
					}else{
						hashField.put("COMTYPE", subE.getAttributeValue("type").trim());
					}
					list = subE.getChildren();
					it2 = list.iterator();
					Element subCom;
					Element subComDiff=(emchild!=null)?emchild.getChild("COMPONENT"):null;
					while (it2.hasNext()) {
						subCom = (Element) it2.next();
						if(subComDiff!=null && subComDiff.getChild(subCom.getName())!=null)
							hashField.put(subCom.getName(), subComDiff.getChild(subCom.getName()).getText().trim());
						else
							hashField.put(subCom.getName(), subCom.getText().trim());
					}	
				}
				if(emchild!=null &&emchild.getChild(subE.getName())!=null){
					hashField.put(subE.getName(), emchild.getChild(subE.getName()).getText());
				}else{
					hashField.put(subE.getName(), subE.getText());
				}
			}
		}	
			ComponentField cf=null;
			if(emchild!=null)
				cf=new ComponentField(objField,emchild);
			else
				cf=new ComponentField(objField);
			hashField.put("cfield",cf);			
			this.fieldGroup.put("all", "*");
			return hashField;
	}	
	private void setAliasField(String fName, String gField) {
		if(this.aliasname==null)
			this.aliasname=new HashMap();
		String [] asname=gField.split(",");
		for(int as=0;as<asname.length;as++){
			this.aliasname.put(asname[as].toLowerCase(), fName.toLowerCase());
		}
	}
	
	private void setGroupField(String fName, String gField) {
		StringTokenizer st = new StringTokenizer(gField, ",");
		Vector gv;
		while (st.hasMoreTokens()) {
			String gName = st.nextToken().toLowerCase();			
			if (this.fieldGroup.containsKey(gName)) {
				gv=(Vector) this.fieldGroup.get(gName);
				if(!gv.contains(fName)){
					gv.add(fName);
				}				
				this.fieldGroup.put(gName, gv);
			} else {
				gv=new Vector();
				gv.add(fName);
				this.fieldGroup.put(gName.toLowerCase(), gv);
			}
		}
	}	
	
	public String getDescThai() {
		return this.descThai;
	}
	public HashMap getFieldGroup() {
		return this.fieldGroup;
	}
	public String getDescEng() {
		return this.descEng;
	}
	public String getEditCheck() {
		return this.editcheck;
	}
	public String getVerify() {
		return this.verify;
	}
	public String getVerifyGroup() {
		return this.verifyGroup;
	}
	public void setLoadComponent(boolean load) {
		this.loadCompo = load;
	}
	public HashMap getRelation() {
		return this.relation;
	}
	public String getMainHelp() {
		return this.mainHelp;
	}
	public String getReferHelp() {
		return this.referHelp;
	}
	public String getMainkey() {
		return this.mainKey;
	}
	public String getWfActive() {
		return this.wfactive;
	}
	public String getWfKey() {
		return this.wfkey;
	}
	public String getDocumentno() {
		return this.documentno;
	}
	public Vector getSystemField() {
		return this.systemField;
	}
	
	/**
	 * @return Returns the deleteFlag.
	 */
	public String getDeleteFlag() {
		return deleteFlag;
	}
	/**
	 * @param deleteFlag The deleteFlag to set.
	 */
	public void setDeleteFlag(String deleteFlag) {
		this.deleteFlag = deleteFlag;
	}
	/**
	 * @return the aliasname
	 */
	public HashMap getAliasname() {
		return aliasname;
	}
	/**
	 * @return the aliasname
	 */
	public Vector getMaindatoryField() {
		return this.maindatoryField;
	}
	/**
	 * @param aliasname the aliasname to set
	 */
	public void setAliasname(HashMap aliasname) {
		this.aliasname = aliasname;
	}
	/**
	 * @return the andCondition
	 */
	public Vector getAndCondition() {
		return andCondition;
	}
	/**
	 * @param andCondition the andCondition to set
	 */
	public void setAndCondition(Vector andCondition) {
		this.andCondition = andCondition;
	}
	/**
	 * @return the orCondition
	 */
	public Vector getOrCondition() {
		return orCondition;
	}
	/**
	 * @param orCondition the orCondition to set
	 */
	public void setOrCondition(Vector orCondition) {
		this.orCondition = orCondition;
	}
	/**
	 * @return the columnNeed
	 */
	public Vector getColumnNeed() {
		return columnNeed;
	}
	/**
	 * @param columnNeed the columnNeed to set
	 */
	public void setColumnNeed(Vector columnNeed) {
		this.columnNeed = columnNeed;
	}
	
	private String convertTable(String tableName) {
		String tName = tableName.toLowerCase();
		return tName.substring(0, 1).toUpperCase() + tName.substring(1, tName.length());
	}
	
	private String getTableName(String classname){
		String tablename="";
		try{
			classname=convertTable(classname);
			Class cs=Class.forName("com.csc.library.databean."+classname);
			tablename=cs.getSuperclass().getName(); 
			tablename=tablename.substring(tablename.lastIndexOf(".")+1,tablename.length());
			if(tablename.toLowerCase().equals("recordcmp0") || tablename.toLowerCase().equals("recordcmp")||tablename.toLowerCase().equals("tpytran0impl"))
				return classname;
			else
				return this.getTableName(tablename);
			
		}catch(Exception ex){
			//MyLog.error(this,ex.getMessage());
			return tablename;
		}
	}
	/**
	 * @return the fieldBlob
	 */
	public Vector getFieldBlob() {
		return fieldBlob;
	}
	/**
	 * @param fieldBlob the fieldBlob to set
	 */
	public void setFieldBlob(Vector fieldBlob) {
		this.fieldBlob = fieldBlob;
	}
	/**
	 * @return the filedUpload
	 */
	public Vector getFiledUpload() {
		return filedUpload;
	}
	/**
	 * @param filedUpload the filedUpload to set
	 */
	public void setFiledUpload(Vector filedUpload) {
		this.filedUpload = filedUpload;
	}
	/**
	 * @return the keyField
	 */
	public PropertyRec getKeyField() {
		return keyField;
	}
	/**
	 * @param keyField the keyField to set
	 */
	public void setKeyField(PropertyRec keyField) {
		this.keyField = keyField;
	}
	/**
	 * @return the allFieldName
	 */
	public Vector getAllFieldName() {
		return allFieldName;
	}
	/**
	 * @param allFieldName the allFieldName to set
	 */
	public void setAllFieldName(Vector allFieldName) {
		this.allFieldName = allFieldName;
	}	
	
	
}
