package com.csc.library.database;

import java.util.Iterator;

import com.csc.library.session.DbRecord;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class PropertyRec extends MyHashMap {
	/**
	 * Constructor for PropertyRec.
	 */
	private boolean check;
	public PropertyRec() {
		super();
		this.check = false;
	}
	public void referLangOn() {
		this.check = true;
		//System.out.println("--------------------------step On-----------------------");
	}
	public void referLangOff() {
		this.check = false;
		//System.out.println("--------------------------step Off-----------------------");
	}
	private Object check(String key) {
		Object obj = super.get(key);
		if (this.getUProfile() == null) {
            MyLog.info(this, this.getUProfile(), "Key <" + key + "> Uprofile <" + this.getUProfile() + ">");
		}
		//   System.out.println(" this.check  <"+this.check+">  ");
		if ((obj != null) && (this.check)) {
			String nameClass = obj.getClass().getName();
			nameClass = nameClass.substring(nameClass.lastIndexOf("."));
			if (nameClass.indexOf("Field") >= 0) {
				FieldManager fm;
				fm = (FieldManager) obj;
				if (!fm.getProperty("REFER_LANG").equals("")) {
					//      	System.out.println("1 "+fm.getName()+"   "+fm.getProperty("REFER_LANG")+" UProfile "+this.getUProfile());
					if (this.getUProfile() != null) {
						//    		System.out.println("2");
						if ((!this.getUProfile().get("lang").equalsIgnoreCase("eng")) && (fm.getLang()=='E')) {
							obj = super.get(fm.getProperty("REFER_LANG").toLowerCase());
							//       System.out.println("Change 2 "+((FieldManager)obj).getName()+"   "+((FieldManager)obj).getValue());
						} else {
							if ((this.getUProfile().get("lang").equalsIgnoreCase("eng")) && (fm.getLang()=='T')) {
								obj = super.get(fm.getProperty("REFER_LANG").toLowerCase());
								//          System.out.println("Change 3 "+((FieldManager)obj).getName()+"   "+((FieldManager)obj).getValue());
							}
						}
					}
				}
			}
		}
		return obj;
	}
	public Object get(Object key) {
		return this.check(((String) key).toLowerCase());
	}
	public Object put(Object key, Object value) {
		return super.put(((String) key).toLowerCase(), value);
	}
	
	public PropertyRec clone(DbRecord db, UProfile upf) {
		PropertyRec hm = new PropertyRec();
		hm.setUProfile(upf);
		if(this.check){
			hm.referLangOn();
		}else{
			hm.referLangOff();
		}
		Iterator it = this.getKeyIterator();
		while (it.hasNext()) {
			Object key =  it.next();
			FieldManager fm = (FieldManager)this.get(key);
			fm.setRecord(db);
			fm.initField(upf);
			hm.put(key, fm.clone());
		}	
		return hm; 
	}
	
	public PropertyRec clone(DbRecord db) {
		PropertyRec hm =this.clone(db, this.getUProfile());
		return hm; 
	}



}
