package com.csc.library.drive;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStream;
import java.io.InputStreamReader;

import com.csc.library.session.InitialEnvironment;
import com.csc.library.utilities.MyLog;
/***
 * 
 * @author odragonfireo
 * Base Map drive on windows
 */
public class BaseMapDrive implements DriveImpl {

	public static String user="";
	public static String pwd="";
	public static String path="";
	public static String drive="";
	public static boolean havedrive=false;
	public static BaseMapDrive mapDrive=null;
	/**
	 * Ǩͺ öҹ
	 */
	public boolean canRead(String drive) throws Exception {
		long millisec=System.currentTimeMillis();
		File f=new File(drive);
		if(f.canRead()){
			millisec=System.currentTimeMillis()-millisec;
			MyLog.info("OK["+millisec+"]!!!!");
			return true;
		}else{
			MyLog.info("FAIL TO CONNECT MAP DRIVE!!!!");
			return false;
		}
	}

	/**
	 * ӡź map drive
	 */
	public void disConnectMapDrive(String drive) throws Exception {
		String command = "net use " + drive + ": /delete";
		excuteCommand(command,"");
	}

	/**
	 * ӡ map drive ҧ
	 * net use x: \\\\192.168.1.212\\d$\\EnterprisePT\\Programmer /user:administrator abc
	 */
	public boolean mapDrive(String drive, String path, String user, String pwd)
			throws Exception {
		
		String command ="net use " + drive + ": " +path + " /user:" + user;
		return excuteCommand(command,pwd);		
	}

	   
    public boolean excuteCommand(String param,String pwd){
		try{
			boolean flag = false;
			MyLog.info("Running: " + param);
			param+=" "+pwd;
			StringBuffer sb = new StringBuffer();
			Process process = Runtime.getRuntime().exec(param);
			InputStream standardInput = process.getInputStream();
			BufferedReader br = new BufferedReader(new InputStreamReader(
			standardInput));
			InputStream standardError = process.getErrorStream();
			BufferedReader brError = new BufferedReader(new InputStreamReader(
			standardError));
			String s;
			while ((s = br.readLine()) != null){
				sb.append(s + "\n");
				flag = true;
			}
			while ((s = brError.readLine()) != null){
				sb.append(s + "\n");
				flag = false;
			}
			standardInput.close();
			standardError.close();
			return flag;
		}catch (Exception e){
			System.out.println(e);
			return false;
		}
	}    
	
    public boolean scanDrive() throws Exception {
		return true;
	}
    
	public DriveImpl init() {
			DriveImpl mapnetwork=null;
		try {
			InitialEnvironment inv = new InitialEnvironment("GLOBAL");
			String ClassName=inv.getValue("mapdrive-classname");

			if(ClassName.length()==0){
					mapnetwork = (DriveImpl)Class.forName("com.csc.library.drive.WindowsMapDrive").newInstance();
				}else{
					mapnetwork=(DriveImpl)Class.forName("com.csc.library.drive."+ClassName).newInstance();
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return mapnetwork;
	}   
	
	public void initEnv(){
		if(!havedrive){
			InitialEnvironment env=new InitialEnvironment("GLOBAL");
			user  = env.getValue("mapdrive-user");
			if(user==""){
				havedrive=false;
				return ;
			}
			pwd   = env.getValue("mapdrive-password");
			path  = env.getValue("mapdrive-path");
			drive = env.getValue("mapdrive-drive");
			havedrive=true;
		}
	}
}
