package com.csc.library.entry;

import java.util.HashMap;
import java.util.StringTokenizer;

import com.csc.library.components.*;
import com.csc.library.database.*;
import com.csc.library.session.DbRecord;
import com.csc.library.utilities.HelpXml;
import com.csc.library.utilities.MyFont;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.StrReplace;

public class HelpEntry2 extends HelpEntry {
	HashMap condiBox  = new HashMap();
	HashMap checkBox  = new HashMap();
	public HelpEntry2() {
		this.type = "helpEntry";
	}
	public void getAndset() {
		super.getAndset();
		this.genCondition();

	}
/*	  public void dataManager(String objName, HashMap param) {
		   if ((this.fixCon != null) && (!this.fixCon.equals("")) && (!this.fixCon.equals("null"))) {
				this.fixCon += " and "+this.getValue("conValue");
			}else{
				this.fixCon=this.getValue("conValue");
			}
		   System.out.println("conValue-->"+this.getValue("conValue")+"  this.fixCon ---->"+this.fixCon+"<----");
			super.dataManager(objName, param);
	  }
	  */
	
	   public void dataManager(String objName, HashMap param) {
	        this.param = param;
	        try {
	            //System.out.println("this.user="+this.user+" objName="+objName+" this.param="+this.param);
	            HelpXml dataControl = new HelpXml(this.user, objName, this.user.getComCode(), this.user.getUserName(), this.user.getPassword(), this.param);
	            this.inq = dataControl.getInquiry();
	     		   if ((this.fixCon != null) && (!this.fixCon.equals("")) && (!this.fixCon.equals("null"))) {
		   				this.fixCon += " and "+this.getValue("conValue");
		   			}else{
		   				this.fixCon=this.getValue("conValue");
		   			}	            	     		  
	            if ((this.fixCon != null) && (!this.fixCon.equals("")) && (!this.fixCon.equals("null"))) {

	   		   
	   			super.dataManager(objName, param);	            	
	            	
	                this.inq.setFilter(this.fixCon);
	                
	            }
	            this.showList = dataControl.showList;
	            this.orderList = dataControl.orderList;
	            // this.logger.info("OredeList dataManager1 :" + this.orderList);
	            // this.fieldReturn = dataControl.returnValue;
	            this.returnList = dataControl.returnList.toLowerCase();
	            this.searchList = dataControl.searchList;
	            // wut edit 10/09/03
	            //			this.logger.debug("returnList ====> " + this.returnList + "<=====");
	            if ((this.orderBy != null) && (!this.orderBy.equals("")) && (!this.orderBy.equals("null"))) {
	                // skip order list
	                //       this.logger.debug("this.orderList-->" + this.orderList +     "<--this.orderBy-->" + this.orderBy + "<--");
	                if ((this.orderList != null) && (!this.orderList.equals("")) ) {
	                    StrReplace rep = new StrReplace();
	                    this.orderList = this.orderBy + "," + rep.replace(this.orderList, this.orderBy.replaceAll(" desc", ""), "");
	                    this.orderList = rep.replace(this.orderList, ",,", ",");
	                    //          this.logger.info("OredeList dataManager2 :" + this.orderList);
	                } else {
	                	// this.orderList = this.orderBy;
	                    //          this.logger.info("OredeList dataManager3 :" + this.orderList);
	                }
	            }
	        } catch (Exception e) {
				MyLog.error(this, this.getUProfile(), e);
	        }
	    }
	protected  void genCondition(){
        FieldManager fm = null;
        DbRecord rec = null;
        String tmp1 = "";
        String table = "";
            for (StringTokenizer token = new StringTokenizer(this.searchList, ","); token.hasMoreTokens();) {
                tmp1 = token.nextToken();
                try {
                    if (tmp1.indexOf(".") < 0) {                    	
                        rec = inq.getCurrentDbRecord();
                        if(table.indexOf(rec.getTableName()+",")<0){
                        	rec.setProperties(true);
                        	table+=rec.getTableName()+",";
                        }
                        fm = rec.getField(tmp1);
                        tmp1 = inq.getTableName() + "." + tmp1;
                    } else {
                        rec = this.getRecord(tmp1.substring(0, tmp1.indexOf(".")), inq.getCurrentDbRecord());
                        if(table.indexOf(rec.getTableName()+",")<0){
                        	rec.setProperties(true);
                        	table+=rec.getTableName()+",";
                        }
                        fm = rec.getField(tmp1.substring(tmp1.indexOf(".") + 1, tmp1.length()));
                    }
                    if(fm!=null){
                    	fm.setHELP_RETURN_FIELD(true);
                    	condiBox.put(fm.getName().toLowerCase(),fm);                    	
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }

            }	
	}
	
	public String getCheckbox(String fieldName){
		fieldName = fieldName.toLowerCase();
		if(this.condiBox.containsKey(fieldName)){
			CheckBox conSearch = new CheckBox();
			conSearch.setUProfile(this.user);
			conSearch.setName("ch"+fieldName);			
			conSearch.setChecked("1");
			conSearch.setValue(this.getValue("ch"+fieldName+"box"));
        return conSearch.process();
		}else{
			return "";
		}
	}
    public String getCondition(String fieldName){
    	fieldName = fieldName.toLowerCase();
    	if(this.condiBox.containsKey(fieldName)){
    		ListBox conSearch = new ListBox();
    		conSearch.setUProfile(this.user);
        	conSearch.setName("condi"+fieldName);
        	conSearch.setValidCode("consearch");
        	conSearch.setChecked(this.getValue("condi"+fieldName));
        	return conSearch.process();
    	}else{
			return "";
		}
    }
    public String getLableCondi(String fieldName){
    	fieldName = fieldName.toLowerCase();
    	if(this.condiBox.containsKey(fieldName)){
    		return ((FieldManager)this.condiBox.get(fieldName)).getDescription();	
      	}else{
			return "";
		}
    }
    public String getInputCondi(String fieldName){
    	fieldName = fieldName.toLowerCase();
    	String dateIcon= "";
    	if(this.condiBox.containsKey(fieldName)){
    		if(this.condiBox.get(fieldName) instanceof FieldDate){
    			dateIcon="<a href=\"javascript:viewCal('__"+fieldName+"');\"  onMouseOut=\"MM_swapImgRestore()\" onMouseOver=\"MM_swapImage('Image"+fieldName+"','','../IMAGES/BUTTON/SWAP/CALENDAR_SWAP20.gif',1)\" > <img src=\"../IMAGES/BUTTON/MAIN/CALENDAR20.gif\" alt=\"Calendar\" name=\"Image"+fieldName+"\" width=\"20\" height=\"20\" border=\"0\" align=\"absmiddle\"></a>";
    		}
    		Text tag = new Text();
    		tag.setUProfile(this.user);
    		tag.setName(fieldName);    	
    		tag.setHelp(((FieldManager)this.condiBox.get(fieldName)).getHelp());
    		tag.setHelpReturn("true");
    		tag.setValue(this.getValue(fieldName));
    		tag.setSize("25");
    		tag.process();
    	return this.charCode("point6",tag.getInput())+dateIcon;
    	}else{    	
    		return "";    	
    	}
    }
    public void setTable() {
        try {
            String tmpLabel, tmp1, tmp2, tmpValue;
            String tableName = "MyTable";
            String star = "&nbsp;";
            int orderField = 0;
            int numField = 0;
            String alignment = "LEFT";
            StringTokenizer token1 = new StringTokenizer(this.showList, ",");
            numField = token1.countTokens();
            this.tableHTML = "<table class=\"large\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" id=\"" + tableName + "\" name=\"" + tableName + "\" >";
            this.tableHTML = this.tableHTML + "<tr>" + this.nextline;
//            if (!this.isHelpReturn()) {
//                this.tableHTML = this.tableHTML + "<TD class=\"HELPHEAD\" WIDTH=\"0%\" HEIGHT=\"0%\">" + " " + "</TD>";
//                orderField++;
//            }
            this.tableHTML = this.tableHTML + "<td class=\"title1\"><div align=\"center\">"  + this.fontHeadT("<script language=\"javascript\">swapLang('Select');</script>") + "</div></td>" + this.nextline;
            for (; token1.hasMoreTokens();) {
                tmp1 = token1.nextToken();
                tmp2 = tmp1.substring(tmp1.indexOf(".") + 1);
                tmp1 = tmp1.substring(0, tmp1.indexOf("."));
                tmpLabel = this.getStringfm(tmp1, tmp2, "desc", false);
         //       this.tableHTML = this.tableHTML + "<TD class=\"HELPHEAD\" WIDTH=\"0%\" HEIGHT=\"0%\" >" + "<a href=\"javascript:sortTable(" + orderField + "," + tableName + ");\">" + this.fontHeadT(tmpLabel) + "</a>" + "</TD>" + this.nextline;
                this.tableHTML = this.tableHTML + "<td class=\"title1\"><div align=\"center\">"  + this.fontHeadT(tmpLabel) + "</div></td>" + this.nextline;
                orderField++;
            }
            this.tableHTML = this.tableHTML + "</tr>" + this.nextline;
            inq.first();
            if ((goPage == null) || (goPage == "")) {
                goPage = "0";
            }
            this.setPeriodRows();
            inq.first();
            if(inq.recCount()>0){
                
            while (inq.next()){
//                if ((inq.recNo() <= (maxLine * Integer.parseInt(goPage))) && (inq.recNo() > (maxLine * (Integer.parseInt(goPage) - 1)))) {
                    this.tableHTML = this.tableHTML + "<tr>" + this.nextline;
                    star = "&nbsp; ";
                    //if this help page is help return not show record status
//                    if (!this.isHelpReturn()) {
//                        this.tableHTML = this.tableHTML + "<TD    class=\"forborder\" WIDTH=\"0%\" HEIGHT=\"0%\" ><DIV ALIGN=\"CENTER\">" + star + "</TD>";
//                    }
                    this.tableHTML = this.tableHTML + "<td class=\"forborder\"><div align=\"center\"><input type='checkbox' name='__box"+inq.recNo()+"' value='"+this.getDataReturn()+"' onClick='javaScript:chselect(this);' ></div></td>" + this.nextline;
                    for (StringTokenizer token = new StringTokenizer(this.showList, ","); token.hasMoreTokens();) {
                        tmp1 = token.nextToken();
                        tmp2 = tmp1.substring(tmp1.indexOf(".") + 1);
                        tmp1 = tmp1.substring(0, tmp1.indexOf("."));
                        tmpValue = this.getStringfm(tmp1, tmp2, "value", false);
                        //if (this.isNumber(tmpValue)){alignment="RIGHT";}else{alignment="LEFT";}
                        if (!this.getStringfm(tmp1, tmp2, "type", false).equalsIgnoreCase("String")) {
                            alignment = "right";
                        } else {
                            alignment = "left";
                        }
   //                     returnValue = this.returnHelp(tmp1);
  /*                      if (this.checkReturn(tmp2)) {
                            this.tableHTML = this.tableHTML + "<TD  class=\"forborder\" WIDTH=\"0%\" HEIGHT=\"0%\" ><DIV ALIGN=\"" + alignment + "\">&nbsp;" + this.getLinkTag(returnValue, this.fontBodyT(tmpValue)) + "&nbsp;</DIV></TD>"
                                    + this.nextline;
                       } else {
                            this.tableHTML = this.tableHTML + "<TD  class=\"forborder\" WIDTH=\"0%\" HEIGHT=\"0%\" ><DIV ALIGN=\"" + alignment + "\">&nbsp;" + this.fontBodyT(tmpValue) + "&nbsp;</DIV></TD>" + this.nextline;
                        }
*/                       
                        this.tableHTML = this.tableHTML + "<td class=\"forborder\">&nbsp;" + this.fontBodyT(tmpValue) + "&nbsp;</td>" + this.nextline;
                    }
                    this.tableHTML = this.tableHTML + "</tr>" + this.nextline;
//                }
//                if (inq.recNo() > (maxLine * Integer.parseInt(goPage))) {
//                    break;
//                }
            }
            }else{
            	for(int i=0;i<numField;i++){
            		this.tableHTML +="<td class=\"forborder\">&nbsp;</td>" + this.nextline;
            	}
            }
            this.tableHTML = this.tableHTML + "</table>";
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
       }
    }
    
    protected String getDataReturn(){
    	String data="";
    	String tmp1="";
        StringTokenizer token1 = new StringTokenizer(this.returnList, ",");
        for (; token1.hasMoreTokens();) {
            tmp1 = token1.nextToken();
            data+=this.getString(tmp1)+"$";
        }
        return data;
    }
    public String printChTableHTML() {
       this.setTable();
        return this.charCode("point6", this.tableHTML);
    }
    public String printTableHTML() {
        super.setTable();
         return this.charCode("point6", this.tableHTML);
     }    
}
