package com.csc.library.formula;
import java.rmi.RemoteException;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;
/**
 * @author @SoCooL@
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class FormulaUtility implements FormulaUtilityManager {
	private FormulaString formulaString = new FormulaString();
	private UProfile uprofile = null;
	public FormulaUtility(UProfile up) {
		this.setUprofile(up);
	}
	/**
	 * Returns the formulaString.
	 * @return FormulaString
	 */
	public FormulaString getFormulaString() {
		return formulaString;
	}
	/**
	 * Sets the formulaString.
	 * @param formulaString The formulaString to set
	 */
	public void setFormulaString(FormulaString formulaString) {
		this.formulaString = formulaString;
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Alltrim(String)
	 */
	public String Alltrim(String st) {
		return this.getFormulaString().Alltrim(st);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Ctod(String)
	 */
	public String Ctod(String st) {
		return this.getFormulaString().Ctod(st);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Day(String)
	 */
	public int Day(String st) {
		return this.getFormulaString().Day(st);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Dec_To_Tm(double)
	 */
	public String Dec_To_Tm(double st) {
		return this.getFormulaString().Dec_To_Tm(st);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#DelFL(String)
	 */
	public String DelFL(String st) {
		return this.getFormulaString().DelFL(st);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#DhmToM(String, double)
	 */
	public int DhmToM(String t, double h) {
		return this.getFormulaString().DhmToM(t, h);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#DhmToM(String)
	 */
	public int DhmToM(String t) {
		return this.getFormulaString().DhmToM(t);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Dow(String)
	 */
	public int Dow(String st) {
		return this.getFormulaString().Dow(st);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Dtoc(String)
	 */
	public String Dtoc(String st) {
		return this.getFormulaString().Dtoc(st);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Int(double)
	 */
	public int Int(double a) {
		return this.getFormulaString().Int(a);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Ltrim(String)
	 */
	public String Ltrim(String st) {
		return this.getFormulaString().Ltrim(st);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Min_to_tm(int)
	 */
	public String Min_to_tm(int i) {
		return this.getFormulaString().Min_to_tm(i);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Month(String)
	 */
	public int Month(String st) {
		return this.getFormulaString().Month(st);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#MTODhm(int, double)
	 */
	public String MTODhm(int m, double h) {
		return this.getFormulaString().MTODhm(m, h);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#MTODhm(int)
	 */
	public String MTODhm(int m) {
		return this.getFormulaString().MTODhm(m);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Round(double, int)
	 */
	public double Round(double n, int a) {
		return this.getFormulaString().Round(n, a);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Round(double)
	 */
	public double Round(double n) {
		return this.getFormulaString().Round(n);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#RoundInt(double)
	 */
	public int RoundInt(double d) {
		return this.getFormulaString().RoundInt(d);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Rtrim(String)
	 */
	public String Rtrim(String st) {
		return this.getFormulaString().Rtrim(st);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Str(double, int)
	 */
	public String Str(double n, int a) {
		return this.getFormulaString().Str(n, a);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Substr(String, int, int)
	 */
	public String Substr(String st, int start, int end) {
		return this.getFormulaString().Substr(st, start, end);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#subtime(double, double)
	 */
	public double subtime(double t, double t1) {
		return this.getFormulaString().subtime(t, t1);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#times(double)
	 */
	public int times(double t) {
		return this.getFormulaString().times(t);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#times1(int)
	 */
	public double times1(int i) {
		return this.getFormulaString().times1(i);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Tm_To_Dec(double)
	 */
	public double Tm_To_Dec(double st) {
		return this.getFormulaString().Tm_To_Dec(st);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Tm_To_Min(double)
	 */
	public int Tm_To_Min(double st) {
		return this.getFormulaString().Tm_To_Min(st);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Val(String)
	 */
	public double Val(String a) {
		return this.getFormulaString().Val(a);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#Year(String)
	 */
	public int Year(String st) {
		return this.getFormulaString().Year(st);
	}
	/**
	 * @see com.csc.library.formula.FormulaUtilityManager#currValue(String, double)
	 */
	public double currValue(String currencyid, double money) {
		double result = 0;
		try {
			DbRecord currencyRecord = new InitialRecord(this.getUprofile()).getDbRecord("Mcurrency");
			currencyRecord.set("currencyid", currencyid);
			currencyRecord.set("_money", money);
			result = currencyRecord.getDouble("_currencyValue");
		} catch (RemoteException e) {
			MyLog.error(this, this.uprofile, e);
		}
		return result;
	}
	/**
	 * Returns the uprofile.
	 * @return UProfile
	 */
	protected UProfile getUprofile() {
		return uprofile;
	}
	/**
	 * Sets the uprofile.
	 * @param uprofile The uprofile to set
	 */
	protected void setUprofile(UProfile uprofile) {
		this.uprofile = uprofile;
	}
}
