package com.csc.library.report;

import java.util.Properties;

import com.csc.library.components.ComponentManager;
import com.csc.library.database.ComponentField;
import com.csc.library.utilities.UProfile;

/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class ReportComponent  implements ComponentManager{
	private UProfile up;
	private Properties prop;
	private ComponentField cfield=new ComponentField();
	public ReportComponent(UProfile up,Properties prop){
		this.prop=prop;
		this.up=up;
	}	
	public String getName(){
		return this.prop.getProperty("name");
	}
	public String getString(){
		return "";
	}
	public String getStringWidth(){
		return this.prop.getProperty("size");
	} //getWidth
	public String getStringDecimal(){
		return this.prop.getProperty("size");
	} //getWidth
	public String getProperty(String code){
		String returnValue=this.prop.getProperty(code);	
		if (returnValue==null)
		return  "";
		else return returnValue;
	}
	public UProfile getUProfile(){
		return this.up;
	}	
	public String getDataFormat() {
		return this.prop.getProperty("value");
	}
	
	public boolean getFormatFlag() {
		return false;
	}
	public String getDescription(){return this.prop.getProperty("desc");}
	public String getDescriptionThai(){return "";}
	public String  getDescriptionEng(){return "";}
	public boolean getHELP_RETURN_FIELD(){return false;}
	public String getComType(){return this.prop.getProperty("COMTYPE");}
	public String  getAlt(){return "";}
	public String getAltEng(){return "";}
	public String  getAltThai(){return "";}
	public String getHelp(){return this.prop.getProperty("HELP");}
	public char isKey(){return '0';}
	public String getDefault(){return "";}
	public String getStringHTML(){return this.prop.getProperty("value");}
	
	public ComponentField getComponentField(){
		return cfield;
	}	
	public char getLang(){return 'A';}
	public boolean isEdit() {
		return true;
	}
	public boolean isRead() {
		return true;
	}	
}
