package com.csc.library.security;

import com.csc.library.utilities.UProfile;

public interface ActionLogImp {
	public String getLogid() ;
	public String getUserName();
	public void setLogid(String logid);
	public void setRemoteip(String remoteip);
	public void setSessionid(String sessionid);
	public void setUserName(String userName);
	public void setUProfile(UProfile up);
	public void lockUserByOverlimit();
	public void lockUserByAdmin();
	public void lockUserByOverTime();
	public void loginComplete();
	public void logoutComplete();
	public void noLogout();
	public void unLockUser();
	public void invalidUser();
	public void userNoActive();
	public void changePassword();
	public void wrongPassword(String password);
	public void waitingTime();
	public long getWaitingTime();
	public void setJspOnline(String logid,String jspPage,String moduleName,String serverName);
	public boolean isLogout();
	public void clearActionlog();
}
