package com.csc.library.session;

import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Vector;

import com.csc.library.utilities.CscCalendar;

public interface Connectable {
	public void process(String processID,String pName,int index,HashMap cond,Vector list) throws RemoteException;
	public boolean isAlive()  throws RemoteException;
	public CscCalendar getLastAction(String processID)  throws RemoteException;
	public void remove(String processID)  throws RemoteException;
	public String getResult(String processID)  throws RemoteException;
	public void findJobToDo() throws RemoteException;
}
