package com.csc.library.session;

import java.lang.reflect.Constructor;

import com.csc.library.security.ActionLogImp;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;
public class InitialActionLog {
	UProfile up;
	String logid;
	String sessionid;
	String remoteip;	
	ActionLogImp ac;
	public InitialActionLog(UProfile up,String logid,String sessionid,String remoteip) {
		this.up=up;
		this.logid=logid;
		this.sessionid=sessionid;
		this.remoteip=remoteip;
	}
	public ActionLogImp getActionLog() {
		try {
			Class c=Class.forName("com.csc.library.authorize.ActionLog");
			Object[] parameterArray = {this.up,this.logid,this.sessionid,this.remoteip};
			Class[] parameterTypeArray = {UProfile.class,String.class,String.class,String.class};
			Constructor cons=c.getConstructor(parameterTypeArray);
			ac=(ActionLogImp)cons.newInstance(parameterArray);
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return this.ac;
	}


}
