package com.csc.library.utilities;

public class MessageProperties {
	private String _MSGCODE="";
	private String _MSGTYPE="";
	private String _MSGTHA="";
	private String _MSGENG="";
	private String _SUGGESTTHA="";
	private String _SUGGESTENG="";
	private String _LANG="ENG";
	
	
	public MessageProperties(String lang){
		this._LANG=lang.toUpperCase();
	}
	
	public MessageProperties(){		
	}
	
	public MessageProperties(String lang,String msgcode,String msgtype,String msgtha,String msgeng,String suggesttha,String suggesteng){
		this.setLANG(lang);
		this.setMSGCODE(msgcode);
		this.setMSGTYPE(msgtype);
		this.setMSGTHA(msgtha);
		this.setMSGENG(msgeng);
		this.setSUGGESTTHA(suggesttha);
		this.setSUGGESTENG(suggesteng);		
	}

	/**
	 * @return the _MSGCODE
	 */
	public String getMSGCODE() {
		return _MSGCODE;
	}
	/**
	 * @param _msgcode the _MSGCODE to set
	 */
	public void setMSGCODE(String _msgcode) {
		_MSGCODE = _msgcode.toUpperCase();
	}
	/**
	 * @return the _MSGENG
	 */
	public String getMSGENG() {
		return _MSGENG;
	}
	/**
	 * @param _msgeng the _MSGENG to set
	 */
	public void setMSGENG(String _msgeng) {
		_MSGENG = _msgeng;
	}
	/**
	 * @return the _MSGTHA
	 */
	public String getMSGTHA() {
		return _MSGTHA;
	}
	/**
	 * @param _msgtha the _MSGTHA to set
	 */
	public void setMSGTHA(String _msgtha) {
		_MSGTHA = _msgtha;
	}
	/**
	 * @return the _MSGTYPE
	 */
	public String getMSGTYPE() {
		return _MSGTYPE;
	}
	/**
	 * @param _msgtype the _MSGTYPE to set
	 */
	public void setMSGTYPE(String _msgtype) {
		_MSGTYPE = _msgtype.toUpperCase();
	}
	/**
	 * @return the _SUGGESTENG
	 */
	public String getSUGGESTENG() {
		return _SUGGESTENG;
	}
	/**
	 * @param _suggesteng the _SUGGESTENG to set
	 */
	public void setSUGGESTENG(String _suggesteng) {
		_SUGGESTENG = _suggesteng;
	}
	/**
	 * @return the _SUGGESTTHA
	 */
	public String getSUGGESTTHA() {
		return _SUGGESTTHA;
	}
	/**
	 * @param _suggesttha the _SUGGESTTHA to set
	 */
	public void setSUGGESTTHA(String _suggesttha) {
		_SUGGESTTHA = _suggesttha;
	}

	/**
	 * @return the _LANG
	 */
	public String getLANG() {
		return _LANG;
	}

	/**
	 * @param _lang the _LANG to set
	 */
	public void setLANG(String _lang) {
		_LANG = _lang.toUpperCase();
	}
	
	public String getMessage(){
		if(this._LANG.equals("THA"))
			return this.getMSGTHA();
		else
			return this.getMSGENG();
	}
	
	public String getSuggest(){
		if(this.getLANG().equals("THA"))
			return this.getSUGGESTTHA();
		else
			return this.getSUGGESTENG();
		
	}
}
