package com.csc.library.utilities;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.StringTokenizer;

public class Parameter {
	Hashtable param = new Hashtable();

	public Parameter() {}

	//this method is called by 'command' class to separate parameter in method
	public void separate(String buffer) {
		for (StringTokenizer token1 = new StringTokenizer(buffer, ","); token1.hasMoreTokens();) {
			StringTokenizer token2 = new StringTokenizer(token1.nextToken(), "=");
			setParameter(token2.nextToken(), token2.nextToken());
		}
	}

	public Object getParameter(String field) {
		if (this.param.containsKey(field))
			return this.param.get(field);
		else
			return null;
	}

	void setParameter(String field, Object value) {
		this.param.put(field, value);
	}

	public String[] getKey() {
		String[] keyParam = new String[this.param.size()];
		int num = 1;
		for (Enumeration enums = this.param.keys(); enums.hasMoreElements();) {
			keyParam[num - 1] = (String) enums.nextElement();
			num++;
		}

		return keyParam;
	}
}