package com.csc.library.utilities;

import java.util.StringTokenizer;

public class ReadReference {
	String index;
	String refArr[];
	boolean isCorrect = false;

	public ReadReference(String refIndex) {
		if (!refIndex.equals("")) {
			this.index = refIndex;
			this.refArr = new String[3];
		} else
			//this.logger.info("Index is null");
		read();
	}

	private void read() {
		String content, allRef;
		int start, end;
		ReadFile refFile = new ReadFile("c:/csc/config/reference.txt");
		content = refFile.getStringWithEnter();
		start = content.indexOf(index);
		if (start != -1) {
			start = content.indexOf("=", start);
			end = content.indexOf(";", start);
			allRef = content.substring(start + 1, end);
		} else
			allRef = "";

		putValue(allRef);
	}

	private void putValue(String allRef) {
		StringTokenizer token = new StringTokenizer(allRef, ",");
		int counter = token.countTokens();
		if (counter == 3) {
			for (int i = 0; i < counter; i++) {
				this.refArr[i] = token.nextToken();
			}
			this.isCorrect = true;
		} else
			MyLog.info(this, "refField error: contain " + token.countTokens() + " parts");
	}

	public boolean canGet() {
		return this.isCorrect;
	}

	public String getRefString(String value) {
		if (value.equalsIgnoreCase("table")) {
			return this.refArr[0];
		} else if (value.equalsIgnoreCase("display")) {
			return this.refArr[1];
		} else if (value.equalsIgnoreCase("value")) {
			return this.refArr[2];
		} else
			return "Incorrect parameter";
	}
}
