package com.csc.library.utilities.compare;
import java.util.Vector;
/**
 * @author somsuksri
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class GenProLog {
	private StringBuffer msg = new StringBuffer();
	private String error = "ERROR !! ", warn = "WARN !! ", info = "INFO ";
	private int errorCount, warnCount, fixCount;
	private String followMain = "\t\t\t\t\t\t-  This Properties follow by main XML .. \n";
	private String addMain = "\t\t\t\t\t\t-  This properties added to main XML .. \n";
	private String higherAdd = "\t\t\t\t\t\t-  Get higher properties added to main XML .. \n";
	private boolean tableNotFound, fieldNotFound, propTableMissmatch, propFieldFixMissmatch, propFieldDynamicMissMatch, relationTableMissMatch, relationFieldMissMatch;
	public void genStartLog(String mainPro, String comPro) {
		msg.append(this.info + "---- START COMPARE PROTALE ----\n");
		msg.append(this.info + "---- MAIN PROTABLE " + mainPro + "\n");
		msg.append(this.info + "---- COMPARE PROTABLE " + comPro + "\n");
	}
	public void genCompleteLog() {
		this.msg.append("\n\nCompleted found error " + this.errorCount + " warn " + this.warnCount + " fix " + this.fixCount + "\n");
	}
	public void genLineLog() {
		msg.append("-------------------------------------------------------");
		msg.append("-------------------------------------------------------\n");
	}
	public void genMissingTableLog(String protable, String tableName) {
		if (this.tableNotFound) {
			msg.append(this.error + "\t\t\t- " + protable + "/" + tableName + "    NOT FOUND PROTABLE !!\n");
			if (protable.equals("Main protable")) {
				msg.append("\t\t\t\t\t\t Generated \n");
			}
			errorCount++;
			this.genLineLog();
		}
	}
	public void genMissingFieldLog(String target, String table, String field) {
		if (this.fieldNotFound) {
			msg.append(this.error + "\t\t\t- " + target + " " + table + " NOT FOUND FIELD " + field + " !!\n");
			if (target.equals("Compare Protable"))
				msg.append(this.followMain);
			else
				msg.append(this.addMain);
			errorCount++;
			this.genLineLog();
		}
	}
	public void genChkFixFieldLog(String type, String key, String value1, String value2, String table, String field) {
		if (this.propFieldFixMissmatch) {
			if (key.equals("type") || key.equals("width")||key.equals("validcode")) {
				msg.append(type + "\t\t\t- " + table + " Field : " + field + ": " + key + " missmatch !!\n");
				msg.append("\t\t\t\t\t\t-  Found ->" + value1 + "<- and ->" + value2 + "<- \n");
				if (key.equalsIgnoreCase("width") && Integer.parseInt(value2) > Integer.parseInt(value1)) {
					msg.append(this.higherAdd);
				} else {
					msg.append(this.followMain);
				}
				if (type.equals(this.error))
					this.errorCount++;
				else
					this.warnCount++;
				this.genLineLog();
			}
		}
	}
	
	public void genChkFixTableLog(String type, String key, String value1, String value2, String table) {
		if (this.propTableMissmatch) {
			if (key.equals("wfactive") || key.equals("mainhelp") || key.equals("referhelp") || key.equals("mainkey")) {
				if (value1 == null && value2 != null) {
					msg.append(type + "\t\t\t- " + table + ": " + key + " missmatch !!\n");
					msg.append("\t\t\t\t\t\t-  Found ->" + value1 + "<- and ->" + value2 + "<- \n");
					msg.append(this.addMain);
					if (type.equals(this.error))
						this.errorCount++;
					else
						this.warnCount++;
				} else if ((value1 != null) && (!value1.equals(value2))) {
					msg.append(type + "\t\t\t- " + table + ": " + key + " missmatch !!\n");
					msg.append("\t\t\t\t\t\t-  Found ->" + value1 + "<- and ->" + value2 + "<- \n");
					msg.append(this.followMain);
					if (type.equals(this.error))
						this.errorCount++;
					else
						this.warnCount++;
				}
			}
		}
	}
	public void genChkDynamicFieldLog(String type, String key, String value1, String value2, String table, String field, Vector passingChk) {
		if (this.propFieldDynamicMissMatch) {
			if (key.equals("key") || key.equals("relation")||key.equals("type")||key.equals("validcode")||key.equals("table")) {
			if (value1 == null && value2 != null) {
				msg.append(type + "\t\t\t- " + table + " Field : " + field + ": " + key + " missmatch !!\n");
				msg.append("\t\t\t\t\t\t-  Found ->" + "Not Specify" + "<- and ->" + value2 + "<- \n");
				if (!key.equalsIgnoreCase("key")) {
					msg.append(this.addMain);
				} else {
					msg.append(this.followMain);
				}
				if (type.equals(this.error))
					this.errorCount++;
				else
					this.warnCount++;
				this.genLineLog();
			}
			if (value1 != null && value2 == null) {
				msg.append(type + "\t\t\t- " + table + " Field : " + field + ": " + key + " missmatch !!\n");
				msg.append("\t\t\t\t\t\t-  Found ->" + value1 + "<- and ->" + "Not Specify" + "<- \n");
				msg.append(this.followMain);
				if (type.equals(this.error))
					this.errorCount++;
				else
					this.warnCount++;
				this.genLineLog();
			}
			if (value1 != null && value2 != null && !passingChk.contains(key)) {
				if (!value1.equals(value2)) {
					msg.append(type + "\t\t\t- " + table + " Field : " + field + ": " + key + " missmatch !!\n");
					msg.append("\t\t\t\t\t\t-  Found ->" + value1 + "<- and ->" + value2 + "<- \n");
					if (key.equals("maxsize") || key.equals("size")) {
						if (Integer.parseInt(value2) > Integer.parseInt(value1)) {
							msg.append(this.higherAdd);
						} else {
							msg.append(this.followMain);
						}
					} else {
						msg.append(this.followMain);
					}
					if (type.equals(this.error))
						this.errorCount++;
					else
						this.warnCount++;
					this.genLineLog();
				}
			}}
		}
	}
	
	public void genMainRelationTableLog(String table, String rTable) {
		if (this.relationTableMissMatch) {
			msg.append(this.error + "\t\t\t- Main protable  Table  " + table + " RELATION missmatch !!\n");
			msg.append("\t\t\t\t\t\t-  Found ->" + "Not Specify" + "<- and ->" + rTable + "<- \n");
			msg.append(this.addMain);
			errorCount++;
			this.genLineLog();
		}
	}
	public void genCompareRelationTableLog(String table, String rTable) {
		if (this.relationTableMissMatch) {
			msg.append(this.error + "\t\t\t- Compare protable  Table  " + table + " RELATION missmatch !!\n");
			msg.append("\t\t\t\t\t\t-  Found ->" + rTable + "<- and ->" + "Not Specify" + "<- \n");
			msg.append(this.followMain);
			errorCount++;
			this.genLineLog();
		}
	}
	public void genMainRelationFieldLog(String type, String table, String rTable, String field) {
		if (this.relationFieldMissMatch) {
			msg.append("FIX" + this.error + "\t\t\t- Main protable  Table  " + table + " Relation to Table " + rTable + "  missmatch!!\n");
			msg.append("\t\t\t\t\t\t-  Found " + type + " ->" + "Not Specify" + "<- and ->" + field + "<- \n");
			msg.append(this.addMain);
			errorCount++;
			fixCount++;
			this.genLineLog();
		}
	}
	public void genCompareRelationFieldLog(String type, String table, String rTable, String field) {
		if (this.relationFieldMissMatch) {
			msg.append(this.error + "\t\t\t- Compare protable  Table  " + table + " Relation to Table " + rTable + "  missmatch!!\n");
			msg.append("\t\t\t\t\t\t-  Found " + type + "->" + field + "<- and ->" + "Not Specify" + "<- \n");
			msg.append(this.followMain);
			errorCount++;
			//fixCount++;	
			this.genLineLog();
		}
	}
	/**
	 * Returns the errorCount.
	 * @return int
	 */
	public int getErrorCount() {
		return errorCount;
	}
	/**
	 * Returns the msg.
	 * @return StringBuffer
	 */
	public StringBuffer getMsg() {
		return msg;
	}
	/**
	 * Returns the warnCount.
	 * @return int
	 */
	public int getWarnCount() {
		return warnCount;
	}
	/**
	 * Sets the errorCount.
	 * @param errorCount The errorCount to set
	 */
	public void setErrorCount(int errorCount) {
		this.errorCount = errorCount;
	}
	/**
	 * Sets the msg.
	 * @param msg The msg to set
	 */
	public void setMsg(StringBuffer msg) {
		this.msg = msg;
	}
	/**
	 * Sets the warnCount.
	 * @param warnCount The warnCount to set
	 */
	public void setWarnCount(int warnCount) {
		this.warnCount = warnCount;
	}
	/**
	 * Returns the error.
	 * @return String
	 */
	public String getError() {
		return error;
	}
	/**
	 * Returns the info.
	 * @return String
	 */
	public String getInfo() {
		return info;
	}
	/**
	 * Returns the warn.
	 * @return String
	 */
	public String getWarn() {
		return warn;
	}
	/**
	 * Sets the error.
	 * @param error The error to set
	 */
	public void setError(String error) {
		this.error = error;
	}
	/**
	 * Sets the info.
	 * @param info The info to set
	 */
	public void setInfo(String info) {
		this.info = info;
	}
	/**
	 * Sets the warn.
	 * @param warn The warn to set
	 */
	public void setWarn(String warn) {
		this.warn = warn;
	}
	/**
	 * Returns the fixCount.
	 * @return int
	 */
	public int getFixCount() {
		return fixCount;
	}
	/**
	 * Sets the fixCount.
	 * @param fixCount The fixCount to set
	 */
	public void setFixCount(int fixCount) {
		this.fixCount = fixCount;
	}
	/**
	 * Returns the fieldNotFound.
	 * @return boolean
	 */
	public boolean isFieldNotFound() {
		return fieldNotFound;
	}
	/**
	 * Returns the propFieldDynamicMissMatch.
	 * @return boolean
	 */
	public boolean isPropFieldDynamicMissMatch() {
		return propFieldDynamicMissMatch;
	}
	/**
	 * Returns the propFieldFixMissmatch.
	 * @return boolean
	 */
	public boolean isPropFieldFixMissmatch() {
		return propFieldFixMissmatch;
	}
	/**
	 * Returns the propTableMissmatch.
	 * @return boolean
	 */
	public boolean isPropTableMissmatch() {
		return propTableMissmatch;
	}
	/**
	 * Returns the relationFieldMissMatch.
	 * @return boolean
	 */
	public boolean isRelationFieldMissMatch() {
		return relationFieldMissMatch;
	}
	/**
	 * Returns the relationTableMissMatch.
	 * @return boolean
	 */
	public boolean isRelationTableMissMatch() {
		return relationTableMissMatch;
	}
	/**
	 * Returns the tableNotFound.
	 * @return boolean
	 */
	public boolean isTableNotFound() {
		return tableNotFound;
	}
	/**
	 * Sets the fieldNotFound.
	 * @param fieldNotFound The fieldNotFound to set
	 */
	public void setFieldNotFound(boolean fieldNotFound) {
		this.fieldNotFound = fieldNotFound;
	}
	/**
	 * Sets the propFieldDynamicMissMatch.
	 * @param propFieldDynamicMissMatch The propFieldDynamicMissMatch to set
	 */
	public void setPropFieldDynamicMissMatch(boolean propFieldDynamicMissMatch) {
		this.propFieldDynamicMissMatch = propFieldDynamicMissMatch;
	}
	/**
	 * Sets the propFieldFixMissmatch.
	 * @param propFieldFixMissmatch The propFieldFixMissmatch to set
	 */
	public void setPropFieldFixMissmatch(boolean propFieldFixMissmatch) {
		this.propFieldFixMissmatch = propFieldFixMissmatch;
	}
	/**
	 * Sets the propTableMissmatch.
	 * @param propTableMissmatch The propTableMissmatch to set
	 */
	public void setPropTableMissmatch(boolean propTableMissmatch) {
		this.propTableMissmatch = propTableMissmatch;
	}
	/**
	 * Sets the relationFieldMissMatch.
	 * @param relationFieldMissMatch The relationFieldMissMatch to set
	 */
	public void setRelationFieldMissMatch(boolean relationFieldMissMatch) {
		this.relationFieldMissMatch = relationFieldMissMatch;
	}
	/**
	 * Sets the relationTableMissMatch.
	 * @param relationTableMissMatch The relationTableMissMatch to set
	 */
	public void setRelationTableMissMatch(boolean relationTableMissMatch) {
		this.relationTableMissMatch = relationTableMissMatch;
	}
	/**
	 * Sets the tableNotFound.
	 * @param tableNotFound The tableNotFound to set
	 */
	public void setTableNotFound(boolean tableNotFound) {
		this.tableNotFound = tableNotFound;
	}
}
